# StructUtils

[![CI](https://github.com/JuliaServices/StructUtils.jl/workflows/CI/badge.svg)](https://github.com/JuliaServices/StructUtils.jl/actions?query=workflow%3ACI)
[![codecov](https://codecov.io/gh/JuliaServices/StructUtils.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaServices/StructUtils.jl)
[![deps](https://juliahub.com/docs/StructUtils/deps.svg)](https://juliahub.com/ui/Packages/StructUtils/HHBkp?t=2)
[![version](https://juliahub.com/docs/StructUtils/version.svg)](https://juliahub.com/ui/Packages/StructUtils/HHBkp)
[![pkgeval](https://juliahub.com/docs/StructUtils/pkgeval.svg)](https://juliahub.com/ui/Packages/StructUtils/HHBkp)

## Installation

The package is registered in the [`General`](https://github.com/JuliaRegistries/General) registry and so can be installed at the REPL with `] add StructUtils`.

## Documentation

- [**STABLE**](https://juliaservices.github.io/StructUtils.jl/stable) &mdash; **most recently tagged version of the documentation.**
- [**LATEST**](https://juliaservices.github.io/StructUtils.jl/dev) &mdash; *in-development version of the documentation.*

## Basic Usage

StructUtils.jl provides macros to enhance struct definitions and tools to convert between different data representations.

### Struct Definition Macros

```julia
using StructUtils, Dates

# @noarg - No-argument constructor for mutable structs
@noarg mutable struct User
    id::Int
    name::String
    created_at::DateTime = now()
    active::Bool = true
end

# Create with empty constructor and set values later
user = User()
user.id = 42
user.name = "Alice"

# @defaults - Default values for trailing fields
@defaults struct Point
    x::Float64
    y::Float64
    z::Float64 = 0.0  # Optional with default value
end

# Create with only required fields (trailing defaults are automatically added)
point = Point(1.0, 2.0)  # Point(1.0, 2.0, 0.0)

# @kwarg - Keyword constructor
@kwarg struct Config
    port::Int = 8080
    host::String = "localhost"
    debug::Bool = false
    timeout::Int = 30
end

# Create with keyword arguments (any/all can be omitted if they have defaults)
config = Config(port=9000, debug=true)  # Config(9000, "localhost", true, 30)

# @tags - Field metadata for custom handling
@tags struct Person
    id::Int &(name="person_id",)
    first_name::String &(name="firstName",)
    birth_date::Date &(dateformat="yyyy-mm-dd",)
    internal_note::String = "" &(ignore=true,)
end

# Default values and field tags can be provided in any of the struct macros: @noarg, @kwarg, @defaults, or @tags
@defaults struct Document
    id::Int
    title::String
    created::DateTime &(dateformat="yyyy-mm-dd HH:MM:SS",)
    status::String = "draft" &(json=(name="documentStatus",),)
end
```

### Programmatic Object Construction

The `StructUtils.make` function allows converting between different data representations:

```julia
# Convert a Dict to a struct
data = Dict(:port => 9000, :host => "example.com", :debug => true)
config = StructUtils.make(Config, data)  # Config(9000, "example.com", true, 30)

# Convert a struct to a Dict
dict = StructUtils.make(Dict{Symbol,Any}, config)  
# Dict(:port => 9000, :host => "example.com", :debug => true, :timeout => 30)

# JSON-like nested structures
person_data = Dict(
    "person_id" => 123,
    "firstName" => "Jane",
    "birth_date" => "1990-01-15"
)
person = StructUtils.make(Person, person_data)  # Person(123, "Jane", Date("1990-01-15"), "")

# Convert between array and Vector
StructUtils.make(Vector{Int}, [1, 2, 3])  # [1, 2, 3]

# Create a nested struct with custom field tags
author = Person(1, "John", Date(1980, 5, 10), "VIP customer")
doc_data = Dict(
    "id" => 42,
    "title" => "Annual Report",
    "created" => "2023-04-15 09:30:00",
    "documentStatus" => "published",
    "author" => StructUtils.make(Dict{String,Any}, author)
)

# Type with field references to other types
@tags struct Article
    id::Int
    title::String
    author::Person &(lower=x -> StructUtils.make(Dict{String,Any}, x),)
end

article = StructUtils.make(Article, doc_data)
# Article(42, "Annual Report", Person(1, "John", Date(1980, 5, 10), ""))
```

## Contributing and Questions

Contributions are very welcome, as are feature requests and suggestions. Please open an
[issue][issues-url] if you encounter any problems or would just like to ask a question.

[ci-img]: https://github.com/JuliaServices/StructUtils.jl/workflows/CI/badge.svg
[ci-url]: https://github.com/JuliaServices/StructUtils.jl/actions?query=workflow%3ACI+branch%3Amaster
[codecov-img]: https://codecov.io/gh/JuliaServices/StructUtils.jl/branch/master/graph/badge.svg
[codecov-url]: https://codecov.io/gh/JuliaServices/StructUtils.jl
[issues-url]: https://github.com/JuliaServices/StructUtils.jl/issues

struct None end
const none = None()

struct FieldExpr
    isconst::Bool
    isatomic::Bool
    name::Symbol
    type::Any # none or Symbol or Expr
    default::Any # literal or Expr or none
    tags::Union{None, Expr}
end

function _expr(f::FieldExpr)
    nm_typ = f.type === none ? f.name : :($(f.name)::$(f.type))
    if f.isconst
        return Expr(:const, nm_typ)
    elseif f.isatomic
        return :(@atomic($nm_typ))
    else
        return nm_typ
    end
end

function _kw(f::FieldExpr)
    # don't include type to allow for more flexible inputs
    # and we can rely on implicit convert call in setfield!
    nm_typ = f.name # f.type === none ? f.name : :($(f.name)::$(f.type))
    return f.default === none ? nm_typ : Expr(:kw, nm_typ, f.default)
end

# parse a single-line field expression
# we progressively peel off layers of the expression to extract field information
# supported field expression types include:
# mutable struct Foo
#     no_type
#     with_type::Int
#     with_default = 1
#     with_type_default::Int = 1
#     with_tag &(xml=(key="with-tag",),)
#     with_tag_type::Int &(xml=(key="with-tag-type",),)
#     with_tag_default = 1 &(xml=(key="with-tag-default",),)
#     with_tag_type_default::Int = 1 &(xml=(key="with-tag-default",),)
#     @atomic no_type_atomic
#     @atomic with_type_atomic::Int
#     @atomic(with_default_atomic) = 1
#     @atomic(with_type_default_atomic::Int) = 1
#     @atomic(with_tag_atomic) &(xml=(key="with-tag-atomic",),)
#     @atomic(with_tag_type_atomic::Int) &(xml=(key="with-tag-type-atomic",),)
#     @atomic(with_tag_default_atomic) = 1 &(xml=(key="with-tag-default-atomic",),)
#     @atomic(with_tag_type_default_atomic::Int) = 1 &(xml=(key="with-tag-default-atomic",),)
#     const no_type_const
#     const with_type_const::Int
#     const with_default_const = 1
#     const with_type_default_const::Int = 1
#     const with_tag_const &(xml=(key="with-tag-const",),)
#     const with_tag_type_const::Int &(xml=(key="with-tag-type-const",),)
#     const with_tag_default_const = 1 &(xml=(key="with-tag-default-const",),)
#     const with_tag_type_default_const::Int = 1 &(xml=(key="with-tag-default-const",),)
# end
function FieldExpr(ex)
    isconst = isatomic = false
    name = Symbol()
    type = none
    default = none
    tags = none
    if Meta.isexpr(ex, :const)
        isconst = true
        ex = ex.args[1]
    end
    if Meta.isexpr(ex, :(=))
        def_and_tags = ex.args[2]
        if Meta.isexpr(def_and_tags, :call) && def_and_tags.args[1] == :&
            default = def_and_tags.args[2]
            tags = def_and_tags.args[3]
        else
            default = def_and_tags
        end
        ex = ex.args[1]
    end
    if Meta.isexpr(ex, :call) && ex.args[1] == :&
        tags = ex.args[3]
        ex = ex.args[2]
    end
    if Meta.isexpr(ex, :atomic)
        isatomic = true
        ex = ex.args[1]
    end
    if ex isa Symbol
        name = ex
    elseif Meta.isexpr(ex, :(::))
        name, type = ex.args
    else
        return nothing
    end
    name = Meta.isexpr(name, :escape) ? name.args[1] : name
    return FieldExpr(isconst, isatomic, name, type, default, tags)
end

function parsefields!(field_exprs::Vector{Any})
    fields = FieldExpr[]
    for (i, fex) in enumerate(field_exprs)
        fex isa LineNumberNode && continue
        f = FieldExpr(fex)
        if f !== nothing
            push!(fields, f)
            # replace field expression that may include defaults/tags w/ just the field name/type
            # + const/atomic annotations
            field_exprs[i] = _expr(f)
        else
            # ignore lines that aren't fields
        end
    end
    return fields
end

function parse_struct_def(kind, src, mod, expr)
    expr = macroexpand(mod, expr)
    Meta.isexpr(expr, :struct) || throw(ArgumentError("Invalid usage of @$kind macro"))
    # kind is: :noarg, :kwarg, :defaults, :tags
    ismutable, T, fieldsblock = expr.args
    if Meta.isexpr(T, :<:)
        T = T.args[1]
    end
    typeparam_names = Symbol[]
    typeparams = Any[]
    if Meta.isexpr(T, :curly)
        T_with_typeparams = copy(T)
        # sanitize T_with_typeparams to remove any type param bounds
        for i = 2:length(T_with_typeparams.args)
            if T_with_typeparams.args[i] isa Expr
                T_with_typeparams.args[i] = T_with_typeparams.args[i].args[1]
            end
            if T_with_typeparams.args[i] isa Symbol
                push!(typeparam_names, T_with_typeparams.args[i])
            end
        end
        typeparams = T.args[2:end]
        T = T.args[1]
    end
    ret = Expr(:block)
    # we always want to return original struct definition expression
    push!(ret.args, :($Base.@__doc__ $expr))
    # parse field exprs and sanitize field definitions
    fields = parsefields!(fieldsblock.args)
    if kind == :noarg
        ismutable || throw(ArgumentError("@noarg structs must be mutable"))
        if any(f.isconst for f in fields)
            #TODO: we could allow non-trailing const fields if they have default values
            # by setting the default value in the initial new() call
            # or if all fields have default values, we could allow const fields
            # because we'd have a value for each field to pass to new()
            throw(ArgumentError("const fields are not allowed in @noarg structs"))
        end
        # generate noarg constructor
        if @isdefined(T_with_typeparams)
            sig = Expr(:where, Expr(:call, T_with_typeparams), typeparams...)
            new_expr = Expr(:(=), :x, Expr(:call, Expr(:curly, :new, T_with_typeparams.args[2:end]...)))
        else
            sig = Expr(:call, T)
            new_expr = :(x = new())
        end
        cexpr = Expr(:function, sig, Expr(:block, src, new_expr))
        defs = [:(setfield!(x, $(Meta.quot(f.name)), $(f.default), $(f.isatomic ? Meta.quot(:sequentially_consistent) : Meta.quot(:not_atomic)))) for f in fields if f.default !== none]
        append!(cexpr.args[2].args, defs)
        push!(cexpr.args[2].args, Expr(:return, :x))
        # add inner constructor right after field definitions
        push!(expr.args[3].args, cexpr)
        #TODO: should we also generate an all-arg constructor like default struct constructors
        # that call convert to the field type for each field?
        # override StructUtils.noarg(::Type{nm}) = true and add outside struct definition
        push!(ret.args, Expr(:(=), Expr(:call, GlobalRef(StructUtils, :noarg), Expr(:(::), GlobalRef(StructUtils, :StructStyle)), Expr(:(::), Expr(:curly, :Type, Expr(:(<:), T)))), true))
        generate_field_defaults_and_tags!(ret, T, fields, typeparam_names, typeparams)
    elseif kind == :kwarg
        if !isempty(fields)
            # generate outer kwarg constructor, like: Foo(; a=1, b=2, ...) = Foo(a, b, ...)
            params = Expr(:parameters, (_kw(fex) for fex in fields)...)
            sig = Expr(:call, T, params)
            fexpr = Expr(:function, sig, Expr(:block, src, :(return $T($((f.name for f in fields)...)))))
            push!(ret.args, fexpr)
            if @isdefined(T_with_typeparams)
                # generate another kwarg constructor with type parameters
                sig = Expr(:where, Expr(:call, T_with_typeparams, params), typeparams...)
                fexpr = Expr(:function, sig, Expr(:block, src, :(return $T_with_typeparams($((f.name for f in fields)...)))))
                push!(ret.args, fexpr)
            end
        end
        # override StructUtils.kwarg(::Type{T}) = true and add outside struct definition
        push!(ret.args, Expr(:(=), Expr(:call, GlobalRef(StructUtils, :kwarg), Expr(:(::), GlobalRef(StructUtils, :StructStyle)), Expr(:(::), Expr(:curly, :Type, Expr(:(<:), T)))), true))
        generate_field_defaults_and_tags!(ret, T, fields, typeparam_names, typeparams)
    elseif kind == :nonstruct
        # Override StructUtils.structlike to return false and add outside struct definition
        push!(ret.args, Expr(:(=), Expr(:call, GlobalRef(StructUtils, :structlike), Expr(:(::), GlobalRef(StructUtils, :StructStyle)), Expr(:(::), Expr(:curly, :Type, Expr(:(<:), T)))), false))
        generate_field_defaults_and_tags!(ret, T, fields, typeparam_names, typeparams)
    else
        # if any default are specified, ensure all trailing fields have defaults
        # then generate multiple outer constructors allowing partial specification
        anydefaults = false
        for (i, f) in enumerate(fields)
            anydefaults |= f.default !== none
            if anydefaults && f.default === none
                throw(ArgumentError("All trailing fields must have default values in @$kind structs"))
            end
        end
        if anydefaults
            # find the first field with a default
            first_default_idx = findfirst(f -> f.default !== none, fields)
            if first_default_idx !== nothing
                # generate constructors for each possible number of arguments
                # from minimum required (non-default fields) up to just before all fields
                non_default_count = first_default_idx - 1
                total_fields = length(fields)
                
                # generate constructors that take k arguments where k goes from
                # non_default_count to (total_fields - 1)
                for num_args in non_default_count:(total_fields - 1)
                    if num_args >= 0
                        # constructor takes first num_args fields as arguments
                        sig = Expr(:call, T, (fields[i].name for i in 1:num_args)...)
                        # build the call to the full constructor
                        call_args = []
                        for (i, f) in enumerate(fields)
                            if i <= num_args
                                push!(call_args, f.name)
                            else
                                push!(call_args, f.default)
                            end
                        end
                        fexpr = Expr(:function, sig, Expr(:block, src, :(return $T($(call_args...)))))
                        push!(ret.args, fexpr)
                        
                        # also generate version with type parameters if applicable
                        if @isdefined(T_with_typeparams)
                            sig_tp = Expr(:where, Expr(:call, T_with_typeparams, (fields[i].name for i in 1:num_args)...), typeparams...)
                            fexpr_tp = Expr(:function, sig_tp, Expr(:block, src, :(return $T_with_typeparams($(call_args...)))))
                            push!(ret.args, fexpr_tp)
                        end
                    end
                end
            end
        end
        generate_field_defaults_and_tags!(ret, T, fields, typeparam_names, typeparams)
    end
    # Return the struct type for REPL friendliness (like Base.@kwdef)
    push!(ret.args, T)
    return esc(ret)
end

_references_typeparam(_, ::Vector{Symbol}) = false
_references_typeparam(s::Symbol, names::Vector{Symbol}) = s in names
_references_typeparam(ex::Expr, names::Vector{Symbol}) =
    any(arg -> _references_typeparam(arg, names), ex.args)

# Build the body of the 2-arg fielddefaults: evaluate default expressions in
# order (so later ones can reference earlier ones), then return a NamedTuple.
function _fielddefaults_body_2arg(fields_with_defaults)
    body = Expr(:block)
    for f in fields_with_defaults
        push!(body.args, Expr(:(=), f.name, f.default))
    end
    defs_nt = Expr(:tuple, Expr(:parameters, [:(($(f.name)=$(f.name))) for f in fields_with_defaults]...))
    push!(body.args, Expr(:return, defs_nt))
    return body
end

# Build the body of the 3-arg fielddefaults: evaluate ALL fields in order,
# preferring `vals[i]` when assigned. Type assertions on `vals[i]` are emitted
# when a field's type is known (for trim safety on computed defaults), but
# skipped when the type references a struct type parameter that isn't bound
# by the method's signature (the unparameterized method).
function _fielddefaults_body_3arg(fields, fields_with_defaults, typeparam_names::Vector{Symbol})
    body = Expr(:block)
    for (i, f) in enumerate(fields)
        skip_assert = f.type === none || _references_typeparam(f.type, typeparam_names)
        val_expr = skip_assert ? :(vals[$i]) : :(vals[$i]::$(f.type))
        if f.default !== none
            push!(body.args, Expr(:(=), f.name, :(isassigned(vals, $i) ? $val_expr : $(f.default))))
        else
            push!(body.args, Expr(:(=), f.name, :(isassigned(vals, $i) ? $val_expr : nothing)))
        end
    end
    defs_nt = Expr(:tuple, Expr(:parameters, [:(($(f.name)=$(f.name))) for f in fields_with_defaults]...))
    push!(body.args, Expr(:return, defs_nt))
    return body
end

function generate_field_defaults_and_tags!(ret, T, fields, typeparam_names::Vector{Symbol}=Symbol[], typeparams::Vector=Any[])
    # generate fielddefaults override if applicable
    if any(f.default !== none for f in fields)
        fields_with_defaults = [f for f in fields if f.default !== none]
        # 2-arg unparameterized: fielddefaults(::StructStyle, ::Type{<:T})
        body_2 = _fielddefaults_body_2arg(fields_with_defaults)
        push!(ret.args, Expr(:(=),
            Expr(:call, GlobalRef(StructUtils, :fielddefaults),
                Expr(:(::), GlobalRef(StructUtils, :StructStyle)),
                Expr(:(::), Expr(:curly, :Type, Expr(:(<:), T)))),
            body_2))
        # 3-arg unparameterized: fielddefaults(::StructStyle, ::Type{<:T}, vals).
        # Skip type assertions whose field type references a struct type parameter,
        # since this signature does not bind the parameters.
        body_3 = _fielddefaults_body_3arg(fields, fields_with_defaults, typeparam_names)
        push!(ret.args, Expr(:(=),
            Expr(:call, GlobalRef(StructUtils, :fielddefaults),
                Expr(:(::), GlobalRef(StructUtils, :StructStyle)),
                Expr(:(::), Expr(:curly, :Type, Expr(:(<:), T))),
                :vals),
            body_3))
        # For parametric structs, also emit parameterized methods that bind the
        # type parameters in scope. They are more specific than the
        # unparameterized methods, so dispatch picks them for concrete calls
        # like fielddefaults(style, Foo{2}); the unparameterized methods remain
        # as the fallback for UnionAll calls (e.g., fielddefaults(style, Foo)).
        # This makes default expressions like `a = ntuple(_->0, N)` and type
        # assertions like `vals[i]::NTuple{N, Symbol}` work for concrete types.
        if !isempty(typeparam_names)
            T_curly = Expr(:curly, T, typeparam_names...)
            body_2p = _fielddefaults_body_2arg(fields_with_defaults)
            push!(ret.args, Expr(:(=),
                Expr(:where,
                    Expr(:call, GlobalRef(StructUtils, :fielddefaults),
                        Expr(:(::), GlobalRef(StructUtils, :StructStyle)),
                        Expr(:(::), Expr(:curly, :Type, Expr(:(<:), T_curly)))),
                    typeparams...),
                body_2p))
            # In the parameterized 3-arg method, type parameters are bound, so we
            # don't need to skip type assertions referencing them; pass an empty
            # typeparam_names vector to retain assertions for trim safety.
            body_3p = _fielddefaults_body_3arg(fields, fields_with_defaults, Symbol[])
            push!(ret.args, Expr(:(=),
                Expr(:where,
                    Expr(:call, GlobalRef(StructUtils, :fielddefaults),
                        Expr(:(::), GlobalRef(StructUtils, :StructStyle)),
                        Expr(:(::), Expr(:curly, :Type, Expr(:(<:), T_curly))),
                        :vals),
                    typeparams...),
                body_3p))
        end
    end
    # generate fieldtags override if applicable
    if any(f.tags !== none for f in fields)
        tags_nt = Expr(:tuple, Expr(:parameters, [:($(f.name)=$(f.tags)) for f in fields if f.tags !== none]...))
        push!(ret.args, Expr(:(=), Expr(:call, GlobalRef(StructUtils, :fieldtags), Expr(:(::), GlobalRef(StructUtils, :StructStyle)), Expr(:(::), Expr(:curly, :Type, Expr(:(<:), T)))), tags_nt))
    end
end

const SHARED_MACRO_DOCS = """
The `@noarg`, `@kwarg`, `@defaults`, and `@tags` macros all support
specifying "field tags" for each field in a struct. Field tags are
a NamedTuple prefixed by `&` and are a way to attach metadata to a field. The
field tags are accessible via the `StructUtils.fieldtags` function, and certain
field tags are used by the `StructUtils.make` function to control how fields are
constructed, including:
  * `dateformat`: a `DateFormat` object to use when parsing or formatting a `Dates.TimeType` field
  * `lower`: a function to apply to a field when `applyeach` is called on a struct
  * `lift`: a function to apply to a field when `StructUtils.make` is called on a struct
  * `ignore`: a `Bool` to indicate if a field should be skipped/ignored when `applyeach` or `make` is called
  * `name`: a `Symbol` to be used instead of a defined field name in `applyeach` or used to match a field in `make`
  * `choosetype`: a function to apply to a field when `StructUtils.make` is called to determine the concrete type of an abstract or Union typed field

For example, the following struct definition includes a field with a `dateformat` tag:
```julia
@tags struct MyStruct
    date::Date &(dateformat=dateformat"yyyy-mm-dd",)
end
```
"""

"""
    @noarg mutable struct T
        ...
    end

Macro to enhance a `mutable struct` definition by automatically
generating an empty or "no-argument" constructor. Similar to the
`@kwarg` macro, default values can be specified for fields, which will
be set in the generated constructor. `StructUtils.noarg` trait is also
overridden to return `true` for the struct type. This allows
structs to easily participate in programmatic construction via
`StructUtils.make`.

Note that `const` fields are currently not allowed in `@noarg` structs.

$SHARED_MACRO_DOCS

Example
```julia
@noarg mutable struct Foo
    a::Int
    b::String
    c::Float64 = 1.0
    d::Vector{Int} = [1, 2, 3]
end
```

In the above example, the `@noarg` macro generates the following inner constructor:
```julia
function Foo()
    x = new()
    x.c = 1.0
    x.d = [1, 2, 3]
    return x
end
```
"""
macro noarg(expr)
    parse_struct_def(:noarg, __source__, __module__, expr)
end

"""
    @kwarg struct T
        ...
    end

Macro to enhance a `struct` definition by automatically generating a
keyword argument constructor. Default values can be specified for fields,
which will be set in the generated constructor. `StructUtils.kwarg` trait is
also overridden to return `true` for the struct type. This allows structs
to easily participate in programmatic construction via `StructUtils.make`.

$SHARED_MACRO_DOCS

Example
```julia
@kwarg struct Foo
    a::Int
    b::String = "foo"
    c::Float64 = 1.0
    d::Vector{Int} = [1, 2, 3]
end
```

In the above example, the `@kwarg` macro generates the following inner constructor:
```julia
function Foo(; a, b="foo", c=1.0, d=[1, 2, 3])
    return Foo(a, b, c, d)
end
```
"""
macro kwarg(expr)
    parse_struct_def(:kwarg, __source__, __module__, expr)
end

"""
    @defaults struct T
        ...
    end

Macro to enhance a `struct` definition by automatically generating an
outer constructor with default values for trailing fields. The generated
constructor will accept arguments for non-default fields and pass default
values to the inner constructor. `StructUtils.fielddefaults` trait is also
overridden to return a `NamedTuple` of default values for the struct type.

$SHARED_MACRO_DOCS

Example
```julia
@defaults struct Foo
    a::Int
    b::String = "foo"
    c::Float64 = 1.0
    d::Vector{Int} = [1, 2, 3]
end
```

In the above example, the `@defaults` macro generates the following outer constructor:
```julia
function Foo(a)
    return Foo(a, "foo", 1.0, [1, 2, 3])
end
```
"""
macro defaults(expr)
    parse_struct_def(:defaults, __source__, __module__, expr)
end

"""
    @tags struct T
        ...
    end

Macro to enhance a `struct` definition by allowing field tags to be
specified for each field.

$SHARED_MACRO_DOCS
"""
macro tags(expr)
    parse_struct_def(:tags, __source__, __module__, expr)
end

"""
    @nonstruct struct T
        ...
    end

Macro to mark a struct as not struct-like for StructUtils purposes. This macro
overrides `StructUtils.structlike` to return `false` for the struct type, which
means that `StructUtils.make` will not attempt to construct the struct using its
fields, but will instead use the `lift` function to convert the source directly
to the struct type.

This is useful for "unit" or "atom" types where the fields should be considered
private to the `make` process and the struct should be constructed by lifting
the source object directly.

**Note**: The `@nonstruct` macro does not support field defaults, field tags, or
other StructUtils macros (`@defaults`, `@tags`, `@noarg`, `@kwarg`) because by
using `@nonstruct`, you are explicitly opting out of StructUtils' struct-like
functionality. The struct's fields are considered private implementation details
for the `make` process.

Example
```julia
@nonstruct struct MyUnit
    value::String
end

# This will use StructUtils.lift to convert the source directly to MyUnit
# rather than trying to construct it from field values
x = StructUtils.make(MyUnit, "hello")
```
"""
macro nonstruct(expr)
    parse_struct_def(:nonstruct, __source__, __module__, expr)
end

module StructUtilsMeasurementsExt

using StructUtils, Measurements

StructUtils.structlike(::Type{<:Measurements.Measurement}) = false
StructUtils.lower(m::Measurements.Measurement) = string(m)
StructUtils.lift(::Type{T}, m::String) where {T<:Measurements.Measurement} = parse(T, m)

end # module

module StructUtils

using Dates, UUIDs

export @noarg, @defaults, @tags, @kwarg, @nonstruct, Selectors

"""
    StructUtils.StructStyle

Abstract type that all concrete struct styles must subtype.
Custom struct styles allow fine-grained control over various
StructUtils.jl interface methods like `fieldtags`, `fielddefaults`,
`lift`, `lower`, etc.
"""
abstract type StructStyle end

"""
    StructUtils.DefaultStyle

Default struct style that all StructUtils.jl interface methods
are defined for by default.
"""
struct DefaultStyle <: StructStyle end

include("macros.jl")

"""
    StructUtils.dictlike(x) -> Bool
    StructUtils.dictlike(::StructStyle, x) -> Bool
    StructUtils.dictlike(::StructStyle, ::Type{T}) -> Bool

Returns `true` if `x` or type `T` is dictionary-like, `false` otherwise.
When `StructUtils.make(T, source)` is called, if `dictlike(T)` is `true`,
an instance will be `initialize`d, and then `addkeyval!`ed for each
key-value pair in `source`.
"""
function dictlike end

dictlike(st::StructStyle, x) = dictlike(st, typeof(x))
dictlike(::StructStyle, T::Type) = dictlike(T)
dictlike(::Type{<:AbstractDict}) = true
dictlike(::Type{<:AbstractVector{<:Pair}}) = true
dictlike(@nospecialize(T)) = false

"""
    StructUtils.noarg(x) -> Bool
    StructUtils.noarg(::StructStyle, x) -> Bool
    StructUtils.noarg(::StructStyle, ::Type{T}) -> Bool

Signals that `x` or type `T` is a mutable type that can be constructed by calling an empty
constructor, like `t = T()`. Automatically overloaded when structs use the
`@noarg` macro in their struct definition. The default value is `false` unless
explicitly overloaded.
"""
function noarg end

noarg(st::StructStyle, x) = noarg(st, typeof(x))
noarg(::StructStyle, T::Type) = noarg(T)
noarg(@nospecialize(T)) = false

"""
    StructUtils.kwarg(x) -> Bool
    StructUtils.kwarg(::StructStyle, x) -> Bool
    StructUtils.kwarg(::StructStyle, ::Type{T}) -> Bool

Signals that `x` or type `T` can be constructed by passing struct fields as keyword arguments
to the constructor, like `t = T(field1=a, field2=b, ...)`. Automatically overloaded
when structs use the `StructUtils.@kwarg` macro in their struct definition. The default value
is `false` unless explicitly overloaded.

Note that `StructUtils.@kwarg` is a separate implementation of `Base.@kwdef`, yet should
be a drop-in replacement for it.
"""
function kwarg end

kwarg(st::StructStyle, x) = kwarg(st, typeof(x))
kwarg(::StructStyle, T::Type) = kwarg(T)
kwarg(@nospecialize(T)) = false

"""
    StructUtils.fieldtagkey(::StructStyle) -> Symbol

Field tags defined on struct fields can be grouped by keys that are associated with
a particular struct style. This function returns the key that should be used to
retrieve field tags for a given struct style. By default, this function returns
`nothing`. An example overload might look like:

```julia
struct MySQLStyle <: StructStyle end

StructUtils.fieldtagkey(::MySQLStyle) = :mysql

@tags struct Foo
    a::Int &(mysql=(name="foo_a",),)
    b::String
end
```

In this example, when `StructUtils.make` is called on `Foo` with the `MySQLStyle` style,
only `(name="foo_a",)` will be retrieved from the field tags for `a` because the
`mysql` key is associated with the `MySQLStyle` struct style. In other words, fieldtag keys
allow custom struct styles to "namespace" field tags so structs can overload specific tags
in multiple ways for different namespaces, i.e. `a::Int &(mysql=(name="foo_a",), json=(name="json_a",))`.
"""
function fieldtagkey end

fieldtagkey(::StructStyle) = nothing

"""
    StructUtils.defaultstate(::StructStyle) -> Any

Returns the default state for a given struct style. This is used to initialize
the state of a struct when no state is provided. The default implementation
returns `nothing`.
"""
defaultstate(::StructStyle) = nothing

"""
    StructUtils.unknownfield(::StructStyle, ::Type{T}, key, value)

Called from [`StructUtils.make`](@ref) and [`StructUtils.make!`](@ref) when a
source key or index does not match any field or positional slot in the target
type `T`.

The default implementation ignores the extra input by returning
[`StructUtils.defaultstate`](@ref). Custom struct styles can overload this to
throw, return [`StructUtils.EarlyReturn`](@ref), or otherwise customize the
behavior for unknown fields.
"""
function unknownfield end

unknownfield(st::StructStyle, ::Type{T}, key, value) where {T} = defaultstate(st)

"""
    StructUtils.fieldtags(::StructStyle, ::Type{T}) -> NamedTuple
    StructUtils.fieldtags(::StructStyle, ::Type{T}, fieldname) -> NamedTuple

Returns a `NamedTuple` of field tags for the struct `T`. Field tags can be
added manually by overloading `fieldtags`, or included via convenient syntax
using the StructUtils.jl macros: `@tags`, `@noarg`, `@defaults`, or `@kwarg`.
Note this function returns the tags of *all* fields as a single NamedTuple.
"""
function fieldtags end

fieldtags(::StructStyle, T::Type)::NamedTuple{(),Tuple{}} = (;)

function fieldtags(st::StructStyle, T::Type, field)
    return _fieldtag(st, fieldtags(st, T), field)
end

function _fieldtag(st::StructStyle, ft, field)
    isempty(ft) && return (;)
    fft = get(ft, field, (;))
    ftk = fieldtagkey(st)
    return ftk === nothing ? fft : get(fft, ftk, fft)
end

@generated function _fieldtagtuple(st::StructStyle, ::Type{T}, fsyms) where {T}
    t = Expr(:tuple)
    for i = 1:fieldcount(T)
        push!(t.args, :(_fieldtag(st, ft, $(QuoteNode(fieldname(T, i))))))
    end
    return quote
        Base.@_inline_meta
        ft = fieldtags(st, T)
        if isempty(ft)
            return _fieldtagtuple_public(st, T, fsyms)
        else
            return $t
        end
    end
end

@generated function _fieldtagtuple_public(st::StructStyle, ::Type{T}, fsyms) where {T}
    t = Expr(:tuple)
    for i = 1:fieldcount(T)
        push!(t.args, :(fieldtags(st, T, $(QuoteNode(fieldname(T, i))))))
    end
    return Expr(:block, :(Base.@_inline_meta), :(return $t))
end

"""
    StructUtils.fielddefaults(::StructStyle, ::Type{T}) -> NamedTuple
    StructUtils.fielddefault(::StructStyle, ::Type{T}, fieldname) -> NamedTuple

Returns a `NamedTuple` of field defaults for the struct `T`. Field defaults can be
added manually by overloading `fielddefaults`, or included via convenient syntax
using the StructUtils.jl macros: `@tags`, `@noarg`, `@defaults`, or `@kwarg`.
"""
function fielddefaults end

fielddefaults(::StructStyle, T::Type)::NamedTuple{(),Tuple{}} = (;)
fielddefaults(st::StructStyle, T::Type, vals) = fielddefaults(st, T)
fielddefault(st::StructStyle, T::Type, key) = get(fielddefaults(st, T), key, nothing)

"See [`fielddefaults`](@ref)."
fielddefault

"""
    StructUtils.initialize(::StructStyle, T, source) -> T

In `StructUtils.make`, this function is called to initialize a new instance of `T`,
when `T` is `dictlike`, `arraylike`, or `noarg`. The `source` is passed from the call to `make`,
and can be used for initialization if appropriate.
The default implementation of `initialize` is to call `T()` or `T(undef, 0)`
for `<:AbstractArray` types.
"""
function initialize end

initialize(st::StructStyle, T::Type, @nospecialize(source)) =
    arraylike(st, T) ? T(undef, 0) : T()

function initialize(st::StructStyle, ::Type{A}, source) where {A<:AbstractArray}
    if ndims(A) > 1
        dims = discover_dims(st, source, ndims(A))
        return A(undef, dims)
    else
        return A(undef, 0)
    end
end

initialize(::StructStyle, ::Type{T}, source) where {T<:AbstractSet} = T()

"""
    StructUtils.addkeyval!(d, k, v)

Add a key-value pair to a dictionary-like object `d`. This function is called
by `StructUtils.make` when `d` is `dictlike`. The default implementation is to
call `d[k] = v` for `AbstractDict`.
"""
function addkeyval! end

addkeyval!(d::AbstractDict, k, v) = d[k] = v
addkeyval!(d::AbstractVector, k, v) = push!(d, k => v)

_keytype(d) = keytype(d)
_keytype(::AbstractVector{Pair{A,B}}) where {A,B} = A
_valtype(d) = valtype(d)
_valtype(::AbstractVector{Pair{A,B}}) where {A,B} = B

"""
    StructUtils.arraylike(x) -> Bool
    StructUtils.arraylike(::StructStyle, x) -> Bool
    StructUtils.arraylike(::StructStyle, ::Type{T}) -> Bool

Returns `true` if `x` or type `T` is array-like, `false` otherwise. This function is
called by `StructUtils.make` to determine if `T` is array-like. The default
implementation returns `true` for `<:AbstractArray`, `<:AbstractSet`, `<:Tuple`,
`<:Base.Generator`, and `<:Core.SimpleVector` types, and `false` for `<:AbstractArray{T,0}`.

Once `initialize` is called, `StructUtils.make` will call `push!` to add values
to the array-like object.
"""
function arraylike end

arraylike(st::StructStyle, x) = arraylike(st, typeof(x))
arraylike(::StructStyle, T::Type) = arraylike(T)
arraylike(::Type{<:AbstractArray{T,0}}) where {T} = false
arraylike(::Type{<:AbstractArray}) = true
arraylike(::Type{<:AbstractSet}) = true
arraylike(::Type{<:Tuple}) = true
arraylike(::Type{<:Base.Generator}) = true
arraylike(::Type{<:Core.SimpleVector}) = true
arraylike(@nospecialize(::Type)) = false
arraylike(@nospecialize(x)) = arraylike(typeof(x))

"""
    StructUtils.fixedsizearray(::Type{T}) -> Bool
    StructUtils.fixedsizearray(::StructStyle, ::Type{T}) -> Bool

Returns `true` if `T` is a fixed-size array type that should be pre-allocated
and filled via `setindex!` rather than grown via `push!`. The default
implementation returns `true` for multidimensional `<:AbstractArray` types
(ndims > 1) and `false` for everything else.

Override this for custom array types that have a fixed, known size but
are not growable (e.g. `StaticArrays.StaticArray`).
"""
function fixedsizearray end

fixedsizearray(::Type) = false
fixedsizearray(::Type{<:AbstractArray{T,N}}) where {T,N} = N > 1
fixedsizearray(::Type{<:AbstractSet}) = false
fixedsizearray(st::StructStyle, ::Type{T}) where {T} = fixedsizearray(T)

"""
    StructUtils.structlike(x) -> Bool
    StructUtils.structlike(::StructStyle, x) -> Bool
    StructUtils.structlike(::StructStyle, ::Type{T}) -> Bool

Returns `true` if `x` or type `T` is struct-like, `false` otherwise. This function is
called by `StructUtils.make` to determine if `T` is struct-like. The default
implementation returns `true` for `isstructtype(T)` and `!Base.issingletontype(T)`.

`structlike` structs are expected to be able to be constructed by the default constructor
like `T(field1, field2, ...)`.

Due to how `StructUtils.make` works, `structlike` is often overloaded to `false` by "unit"/"atom" types
where fields should be considered private to the `make` process and should instead attempt to
`lift` the `source` object into the `unit` type.
"""
function structlike end

structlike(st::StructStyle, x) = structlike(st, typeof(x))
structlike(::StructStyle, T::Type) = structlike(T)
structlike(::Type{<:Function}) = false
structlike(::Type{<:Module}) = false
structlike(::Type{<:AbstractArray{T,0}}) where {T} = false
structlike(::Type{<:AbstractChar}) = false
structlike(::Type{<:AbstractString}) = false
structlike(::Type{Symbol}) = false
structlike(::Type{Regex}) = false
structlike(::Type{<:Dates.TimeType}) = false
structlike(::Type{Number}) = false
structlike(::Type{BigInt}) = false
structlike(::Type{BigFloat}) = false
structlike(::Type{Nothing}) = false
structlike(::Type{Missing}) = false
structlike(::Type{UUID}) = false
structlike(::Type{VersionNumber}) = false
structlike(::Type{MIME}) = false
structlike(::Type{<:NamedTuple}) = true
structlike(@nospecialize(x)) = structlike(typeof(x))
structlike(@nospecialize(T::Type)) = isstructtype(T) && !Base.issingletontype(T)

"""
    StructUtils.nulllike(x) -> Bool
    StructUtils.nulllike(::StructStyle, x) -> Bool
    StructUtils.nulllike(::StructStyle, ::Type{T}) -> Bool

Returns `true` if `x` or type `T` is null-like, `false` otherwise. This function is
mainly used in the `make!` implementation to determine if a
`Union` type can be narrowed by excluding `nulllike` types like `Nothing` and `Missing`.
"""
function nulllike end

nulllike(st::StructStyle, x) = nulllike(st, typeof(x))
nulllike(::StructStyle, T::Type) = nulllike(T)
nulllike(@nospecialize(T)) = T === Missing || T === Nothing

"""
    StructUtils.lower(x) -> x
    StructUtils.lower(::StructStyle, x) -> x

Domain value transformation function. This function is called by
`StructUtils.applyeach` on each value in the `source` object before
calling the apply function. By default, `lower` is the identity function.
This allows a domain transformation of values according to the
style used.

When [`StructUtils.make`](@ref) uses a structural or container builder, it
also calls `lower` once on a root source that is not struct-like. Struct-like
root sources are traversed directly, so their `lower` methods may call `make`
to reuse its field mapping without recursion.
"""
function lower end

lower(::StructStyle, x) = lower(x)
lower(x) = x

function lower(st::StructStyle, x, tags)
    # there are a few builtin tags supported
    if x isa Dates.TimeType && haskey(tags, :dateformat)
        return Dates.format(x, tags.dateformat)
    elseif haskey(tags, :lower)
        return tags.lower(x)
    else
        return lower(st, x)
    end
end

"""
    StructUtils.lowerkey(x) -> x
    StructUtils.lowerkey(style::StructUtils.StructStyle, x) -> x

Allows customizing how a value is lowered when used specifically as a key.
By default, calls [`StructUtils.lower`](@ref). Called from [`StructUtils.applyeach`](@ref)
on the key or index before passed to the key-value function.

### Example

```julia
struct Point
    x::Int; y::Int
end

# lower a Point as a single string value
StructUtils.lowerkey(::StructUtils.StructStyle, p::Point) = "\$(p.x)_\$(p.y)"

d = Dict(Point(1, 2) => 99)

StructUtils.make(Dict{String, Dict{String, Point}}, Dict(Point(1, 2) => Dict(Point(3, 4) => Point(5, 6))))
# Dict{String, Dict{String, Point}} with 1 entry:
#   "1_2" => Dict("3_4"=>Point(5, 6))
```

For loss-less round-tripping also provide a [`StructUtils.liftkey`](@ref) overload to "lift" the key back.
"""
lowerkey(::StructStyle, x) = lowerkey(x)
lowerkey(x) = x

"""
    StructUtils.lift(::Type{T}, x) -> T
    StructUtils.lift(::StructStyle, ::Type{T}, x) -> Tuple{T, Any}

Lifts a value `x` to a type `T`. This function is called by `StructUtils.make`
to lift unit/atom values to the appropriate type. The default implementation is
the identity function for most types, but it also includes special cases
for `Symbol`, `Char`, `UUID`, `VersionNumber`, `MIME`, `Regex`, and `TimeType` types to be
constructed from strings.
Allows transforming a "domain value" that may be some primitive representation
into a more complex Julia type.

The method with a `StructStyle` argument should return a tuple of the lifted value and any side-effect state
derived from lifting the value.
"""
function lift end

lift(::Type{Symbol}, x) = Symbol(x)
lift(::Type{String}, x::Symbol) = String(x)
lift(::Type{T}, x) where {T} = Base.issingletontype(T) ? T() : convert(T, x)
lift(::Type{>:Missing}, ::Nothing) = missing
lift(::Type{>:Nothing}, ::Nothing) = nothing
lift(::Type{>:Union{Missing,Nothing}}, ::Nothing) = nothing
lift(::Type{>:Union{Missing,Nothing}}, ::Missing) = missing
lift(::Type{Char}, x::AbstractString) = length(x) == 1 ? x[1] : throw(ArgumentError("expected single character, got $x"))
lift(::Type{UUID}, x::AbstractString) = UUID(x)
lift(::Type{VersionNumber}, x::AbstractString) = VersionNumber(x)
lift(::Type{MIME}, x::AbstractString) = MIME(x)
lift(::Type{Regex}, x::AbstractString) = Regex(x)
lift(::Type{T}, x::AbstractString) where {T<:Dates.TimeType} = T(x)
lift(::Type{Dates.Date}, x::AbstractString) = _liftdate(String(x))
lift(::Type{Dates.DateTime}, x::AbstractString) = _liftdatetime(String(x))
lift(::Type{Dates.Time}, x::AbstractString) = _lifttime(String(x))

# ISO 8601 parsers for the three core Dates types. The `Date(str)` family
# routes through the DateFormat machinery, whose token handling and
# diagnostics are too dynamic for static compilation (`juliac --trim`); these
# accept exactly the grammar the default formats do — variable-width numeric
# fields, an optional year sign, progressively optional smaller fields, and a
# 1-3 digit fraction — and construct through the validating constructors.
@inline function _isodigits(s::String, i::Int, maxwidth::Int)
    n = ncodeunits(s)
    value = 0
    width = 0
    while i <= n && width < maxwidth
        b = codeunit(s, i)
        (UInt8('0') <= b <= UInt8('9')) || break
        value = 10 * value + Int(b - UInt8('0'))
        i += 1
        width += 1
    end
    return width == 0 ? -1 : value, i
end

@inline _isochar(s::String, i::Int, c::Char) =
    i <= ncodeunits(s) && codeunit(s, i) == UInt8(c)

# The default formats treat input as the token sequence
# `y - m - d T H : M : S . s` (dates stop after `d`, times start at `H`):
# numeric fields are variable-width, the year may carry a sign, delimiters
# must match in exact order, and input may end after any complete token —
# remaining fields default. A missing numeric field, a wrong delimiter, or
# trailing content is an error.
macro _isofield(var, maxwidth)
    esc(quote
        i > n && @goto done
        $var, i = _isodigits(s, i, $maxwidth)
        $var == -1 && throw(ArgumentError(errmsg))
    end)
end

macro _isodelim(c)
    esc(quote
        i > n && @goto done
        codeunit(s, i) == UInt8($c) || throw(ArgumentError(errmsg))
        i += 1
    end)
end

function _isoparse(s::String, withdate::Bool, withtime::Bool)
    errmsg = withtime ? (withdate ? "invalid ISO 8601 date-time" : "invalid ISO 8601 time") : "invalid ISO 8601 date"
    n = ncodeunits(s)
    i = 1
    y = 0
    m = 1
    d = 1
    h = 0
    mi = 0
    sec = 0
    ms = 0
    if withdate
        negative = _isochar(s, i, '-')
        (negative || _isochar(s, i, '+')) && (i += 1)
        y, i = _isodigits(s, i, 18)
        y == -1 && throw(ArgumentError(errmsg))
        negative && (y = -y)
        @_isodelim '-'
        @_isofield m 2
        @_isodelim '-'
        @_isofield d 2
        withtime || @goto done
        @_isodelim 'T'
        @_isofield h 2
    else
        # the leading field is required: time-only input may not be empty
        h, i = _isodigits(s, i, 2)
        h == -1 && throw(ArgumentError(errmsg))
    end
    @_isodelim ':'
    @_isofield mi 2
    @_isodelim ':'
    @_isofield sec 2
    @_isodelim '.'
    i > n && @goto done
    fraction_start = i
    ms, i = _isodigits(s, i, 3)
    ms == -1 && throw(ArgumentError(errmsg))
    # the fraction is at most three digits (milliseconds), scaled as if
    # right-padded: ".4" is 400 milliseconds
    for _ = 1:(3 - (i - fraction_start))
        ms *= 10
    end
    @label done
    i > n || throw(ArgumentError(errmsg))
    return y, m, d, h, mi, sec, ms
end

function _liftdate(s::String)
    y, m, d, _, _, _, _ = _isoparse(s, true, false)
    return Dates.Date(y, m, d)
end

function _liftdatetime(s::String)
    # `DateTime(str)` rejects time-zone designators, but RFC 3339 date-times
    # with an offset — `2026-08-07T15:00:00Z`, `…+02:00` — are what most JSON
    # producers emit. Accept them here and normalize to UTC; without an
    # offset the value is taken as-is, exactly like the constructor.
    n = ncodeunits(s)
    offsetminutes = 0
    body = s
    if n > 1 && codeunit(s, n) == UInt8('Z') &&
       any(i -> codeunit(s, i) == UInt8('T'), 1:(n - 1))
        body = String(view(codeunits(s), 1:(n - 1)))
    elseif n >= 6 &&
           (codeunit(s, n - 5) == UInt8('+') || codeunit(s, n - 5) == UInt8('-')) &&
           codeunit(s, n - 2) == UInt8(':') &&
           # require a 'T' before the sign so a date's own '-' never matches
           any(i -> codeunit(s, i) == UInt8('T'), 1:(n - 6))
        all(i -> UInt8('0') <= codeunit(s, i) <= UInt8('9'), (n - 4, n - 3, n - 1, n)) ||
            throw(ArgumentError("invalid ISO 8601 date-time"))
        hours = 10 * Int(codeunit(s, n - 4) - UInt8('0')) +
                Int(codeunit(s, n - 3) - UInt8('0'))
        minutes = 10 * Int(codeunit(s, n - 1) - UInt8('0')) +
                  Int(codeunit(s, n) - UInt8('0'))
        offsetminutes = (codeunit(s, n - 5) == UInt8('+') ? -1 : 1) *
                        (60 * hours + minutes)
        body = String(view(codeunits(s), 1:(n - 6)))
    end
    y, m, d, h, mi, sec, ms = _isoparse(body, true, true)
    value = Dates.DateTime(y, m, d, h, mi, sec, ms)
    return offsetminutes == 0 ? value : value + Dates.Minute(offsetminutes)
end

function _lifttime(s::String)
    _, _, _, h, mi, sec, ms = _isoparse(s, false, true)
    return Dates.Time(h, mi, sec, ms)
end

function lift(::Type{T}, x::AbstractString) where {T<:Enum}
    sym = Symbol(x)
    for (k, v) in Base.Enums.namemap(T)
        v === sym && return T(k)
    end
    throw(ArgumentError("invalid `$T` string value: \"$sym\""))
end

lift(st::StructStyle, ::Type{T}, x) where {T} = lift(T, x), defaultstate(st)

# bit of an odd case, but support 0-dimensional array lifting from scalar value
function lift(st::StructStyle, ::Type{A}, x) where {A<:AbstractArray{T,0}} where {T}
    m = A(undef)
    m[1] = lift(st, T, x)
    return m, defaultstate(st)
end

function lift(st::StructStyle, ::Type{T}, x, tags) where {T}
    if haskey(tags, :lift)
        return tags.lift(x), defaultstate(st)
    elseif T <: Dates.TimeType && haskey(tags, :dateformat)
        if tags.dateformat isa String
            return parse(T, x, Dates.DateFormat(tags.dateformat)), defaultstate(st)
        else
            return parse(T, x, tags.dateformat), defaultstate(st)
        end
    else
        return lift(st, T, x)
    end
end

"""
    StructUtils.liftkey(::Type{T}, x) -> x
    StructUtils.liftkey(style::StructStyle, ::Type{T}, x) -> x

Allows customizing how a key is lifted before being passed to [`addkeyval!`](@ref)
in `dictlike` construction.

By default, calls [`StructUtils.lift`](@ref).

### Example

```julia
struct Point
    x::Int; y::Int
end

# lift a Point from a string value
StructUtils.liftkey(::StructUtils.StructStyle, x::String) = Point(parse(Int, split(x, "_")[1]), parse(Int, split(x, "_")[2]))

d = Dict("1_2" => 99)
StructUtils.make(Dict{Point, Int}, Dict("1_2" => 99))
# Dict{Point, Int} with 1 entry:
#   Point(1, 2) => 99
```

For loss-less round-tripping also provide a [`StructUtils.lowerkey`](@ref) overload to "lower" the key.
"""
function liftkey end

liftkey(::StructStyle, ::Type{T}, x) where {T} = liftkey(T, x)
liftkey(::Type{T}, x) where {T} = lift(T, x)
liftkey(f, st::StructStyle, ::Type{T}, x) where {T} = f(liftkey(st, T, x))

"""
    StructUtils.applyeach(style, f, x) -> Union{StructUtils.EarlyReturn, Nothing}

A custom `foreach`-like function that operates specifically on `(key, val)` or `(ind, val)` pairs,
and supports short-circuiting (via `StructUtils.EarlyReturn`). It also supports a `StructStyle` argument
to allow for style-specific behavior for non-owned types.

For each key-value or index-value pair in `x`, call `f(k, v)`.
If `f` returns a `StructUtils.EarlyReturn` instance, `applyeach` should
return the `EarlyReturn` immediately and stop iterating (i.e. short-circuit).
Otherwise, the return value of `f` can be ignored and iteration continues.

Key types are generally expected to be Symbols, Strings, or Integers.

An example overload of `applyeach` for a generic iterable would be:

```julia
function StructUtils.applyeach(style::StructUtils.StructStyle, f, x::MyIterable)
    for (i, v) in enumerate(x)
        ret = f(StructUtils.lowerkey(style, i), StructUtils.lower(style, v))
        # if `f` returns EarlyReturn, return immediately
        ret isa StructUtils.EarlyReturn && return ret
    end
    return
end
```

Note that `applyeach` must include the `style` argument when overloading.

Also note that before applying `f`, the key or index is passed through `StructUtils.lowerkey(style, k)`,
and the value `v` is passed through `StructUtils.lower(style, v)`.

If a value is `#undef` or otherwise not defined, the `f` function should generally be called with `nothing` or skipped.
"""
function applyeach end

"""
    StructUtils.EarlyReturn{T}

A wrapper type that can be used in function arguments to `applyeach`
to short-circuit iteration and return a value from `applyeach`.

Example usage:

```julia
function find_needle_in_haystack(haystack, needle)
    ret = applyeach(haystack) do k, v
        k == needle && return StructUtils.EarlyReturn(v)
    end
    ret isa StructUtils.EarlyReturn && return ret.value
    throw(ArgumentError("needle not found in haystack"))
end
```
"""
struct EarlyReturn{T}
    value::T
end

struct _MatchedState{T}
    value::T
end

applyeach(f, x) = applyeach(DefaultStyle(), f, x)
applyeach(f, st::StructStyle, x) = applyeach(st, f, x)

function applyeach(st::StructStyle, f, x::AbstractArray)
    for i in eachindex(x)
        ret = if @inbounds(isassigned(x, i))
            f(lowerkey(st, i), lower(st, @inbounds(x[i])))
        else
            f(lowerkey(st, i), lower(st, nothing))
        end
        ret isa EarlyReturn && return ret
    end
    return defaultstate(st)
end

# special-case Pair vectors to act like Dicts
function applyeach(st::StructStyle, f, x::AbstractVector{Pair{K,V}}) where {K,V}
    for (k, v) in x
        ret = f(lowerkey(st, k), lower(st, v))
        ret isa EarlyReturn && return ret
    end
    return defaultstate(st)
end

# special-case Pair to act like key-value object
function applyeach(st::StructStyle, f, x::Pair)
    ret = f(lowerkey(st, x.first), lower(st, x.second))
    ret isa EarlyReturn && return ret
    return defaultstate(st)
end

# appropriate definition for iterables that
# can't have #undef values
function applyeach(st::StructStyle, f, x::Union{AbstractSet,Base.Generator,Core.SimpleVector})
    for (i, v) in enumerate(x)
        ret = f(lowerkey(st, i), lower(st, v))
        ret isa EarlyReturn && return ret
    end
    return defaultstate(st)
end

# generic definition for Tuple, NamedTuple, structs
function applyeach(st::StructStyle, f, x::T) where {T}
    if @generated
        N = fieldcount(T)
        ex = quote
            defs = fielddefaults(st, T)
        end
        for i = 1:N
            fname = Meta.quot(fieldname(T, i))
            push!(ex.args, quote
                ftags = fieldtags(st, T, $fname)
                if !haskey(ftags, :ignore) || !ftags.ignore
                    fname = get(ftags, :name, $fname)
                    ret = if isdefined(x, $i)
                        f(lowerkey(st, fname), lower(st, getfield(x, $i), ftags))
                    elseif haskey(defs, $fname)
                        # this branch should be really rare because we should
                        # have applied a field default in the struct constructor
                        f(lowerkey(st, fname), lower(st, defs[$fname], ftags))
                    else
                        f(lowerkey(st, fname), lower(st, nothing, ftags))
                    end
                    ret isa EarlyReturn && return ret
                end
            end)
        end
        push!(ex.args, :(return defaultstate(st)))
        return ex
    else
        defs = fielddefaults(st, T)
        for i = 1:fieldcount(T)
            fname = fieldname(T, i)
            ftags = fieldtags(st, T, fname)
            if !haskey(ftags, :ignore) || !ftags.ignore
                fname = get(ftags, :name, fname)
                ret = if isdefined(x, i)
                    f(lowerkey(st, fname), lower(st, getfield(x, i), ftags))
                elseif haskey(defs, fname)
                    f(lowerkey(st, fname), lower(st, defs[fname], ftags))
                else
                    f(lowerkey(st, fname), lower(st, nothing, ftags))
                end
                ret isa EarlyReturn && return ret
            end
        end
        return defaultstate(st)
    end
end

function applyeach(st::StructStyle, f, x::AbstractDict)
    for (k, v) in x
        ret = f(lowerkey(st, k), lower(st, v))
        ret isa EarlyReturn && return ret
    end
    return defaultstate(st)
end

@static if VERSION < v"1.10"
    function _isfieldatomic(t::Type, s::Int)
        t = Base.unwrap_unionall(t)
        # TODO: what to do for `Union`?
        isa(t, DataType) || return false # uncertain
        ismutabletype(t) || return false # immutable structs are never atomic
        1 <= s <= length(t.name.names) || return false # OOB reads are not atomic (they always throw)
        atomicfields = t.name.atomicfields
        atomicfields === C_NULL && return false
        s -= 1
        return unsafe_load(Ptr{UInt32}(atomicfields), 1 + s ÷ 32) & (1 << (s % 32)) != 0
    end
else
    const _isfieldatomic = Base.isfieldatomic
end

_setfield!(x, i, v) = setfield!(x, i, v, _isfieldatomic(typeof(x), i) ? :sequentially_consistent : :not_atomic)

keyeq(a::Symbol, b::String) = a === Symbol(b)
keyeq(a::String, b::Symbol) = Symbol(a) == b
keyeq(a, b::String) = string(a) == b
keyeq(a::AbstractString, b::String) = String(a) == b
keyeq(a, b::Tuple) = any(keyeq(a), b)
keyeq(a, b) = isequal(a, b)
keyeq(x) = y -> keyeq(x, y)

macro _f(i)
    esc(:(x = f($i); x isa EarlyReturn && return x.value))
end

@generated function _foreach(f, ::Type{T}) where {T}
    # marked inline since this benefits from constant propagation of `n`
    n = fieldcount(T)
    ex = Expr(:block)
    push!(ex.args, :(Base.@_inline_meta))
    for i = 1:n
        push!(ex.args, :(@_f($i)))
    end
    return ex
    return
end

# helper closure that computes the length of an applyeach source
# note that it should be used sparingly/carefully since it consumes
# the source object and we generally want to do a single pass
if VERSION < v"1.10"
    mutable struct LengthClosure
        len::Int
    end
    (f::LengthClosure)(_, _) = f.len += 1
    function applylength(x)
        lc = LengthClosure(0)
        StructUtils.applyeach(lc, x)
        return lc.len
    end
else
    struct LengthClosure
        len::Ptr{Int}
    end

    (f::LengthClosure)(_, _) = unsafe_store!(f.len, unsafe_load(f.len) + 1)

    function applylength(x)
        ref = Ref(0)
        GC.@preserve ref begin
            lc = LengthClosure(Base.unsafe_convert(Ptr{Int}, ref))
            StructUtils.applyeach(lc, x)
            return unsafe_load(lc.len)
        end
    end
end # VERSION < v"1.10"

# recursively build up multidimensional array dimensions
# "[[1.0],[2.0]]" => (1, 2)
# "[[1.0,2.0]]" => (2, 1)
# "[[[1.0]],[[2.0]]]" => (1, 1, 2)
# "[[[1.0],[2.0]]]" => (1, 2, 1)
# "[[[1.0,2.0]]]" => (2, 1, 1)
# length of innermost array is 1st dim
function discover_dims(style, x, ndims::Int)
    @assert arraylike(style, x)
    len = applylength(x)
    if ndims == 1
        return (len,)
    end

    ret = (
        applyeach(x) do _, v
            return arraylike(style, v) ? EarlyReturn(discover_dims(style, v, ndims - 1)) : EarlyReturn(())
        end
    )::EarlyReturn
    return (ret.value..., len)
end

"""
    StructUtils.discover_dims(style, ::Type{T}, source) -> Tuple

Discover the dimensions for a fixed-size array type `T`. By default,
delegates to `discover_dims(style, source, ndims(T))` to scan the source object.
Override for types where dimensions are encoded in the type itself
(e.g. `StaticArrays.StaticArray`), avoiding the need to scan the source.
"""
discover_dims(style, ::Type{T}, source) where {T} = discover_dims(style, source, ndims(T))

"""
    StructUtils.arrayfromdata(::Type{T}, mem, dims::Tuple) -> T

Convert a filled data buffer `mem` with shape `dims` into the target array
type `T`. Called at the end of `makearray` for `fixedsizearray` types.
"""
function arrayfromdata end

arrayfromdata(::Type{T}, buf::Vector, dims::Tuple) where {T<:AbstractArray} =
    reshape(buf, dims)

if VERSION >= v"1.11"
    arrayfromdata(::Type{T}, mem::Memory, dims::Tuple) where {T<:AbstractArray} =
        Base.wrap(Array, Base.memoryref(mem), dims)
end

struct MultiDimClosure{S,A}
    style::S
    arr::A
    dims::Vector{Int}
    cur_dim::Base.RefValue{Int}
end

function (f::MultiDimClosure{S,A})(i::Int, val) where {S,A}
    f.dims[f.cur_dim[]] = i
    if arraylike(f.style, val) && f.cur_dim[] > 1
        f.cur_dim[] -= 1
        st = applyeach(f, f.style, val)
        f.cur_dim[] += 1
    else
        val, st = make(f.style, eltype(f.arr), val)
        setindex!(f.arr, val, f.dims...)
    end
    return st
end

struct MultiDimValFunc{S,A}
    style::S
    arr::A
    dims::Vector{Int}
end

(f::MultiDimValFunc{S,A})(x) where {S,A} = setindex!(f.arr, x, f.dims...)

"""
    StructUtils.make(T, source) -> T
    StructUtils.make(T, source, style) -> T
    StructUtils.make(style, T, source) -> Tuple{T, Any}
    StructUtils.make!(style, x::T, source)

Construct a struct of type `T` from `source` using the given `style`. The `source` can be any
type of object, and the `style` can be any `StructStyle` subtype (default `StructUtils.DefaultStyle()`).

`make` will use any knowledge of `noarg`, `arraylike`, or `dictlike` in order to
determine how to construct an instance of `T`. The fallback for structs is to rely on
the automatic "all argument" constructor that structs have defined by default (e.g. `T(fields...)`).

`make` calls `applyeach` on the `source` object, where the key-value pairs
from `source` will be used in constructing `T`.

Before structural construction, `make` calls [`StructUtils.lower`](@ref) on a
root source for which [`StructUtils.structlike`](@ref) is `false`. Struct-like
root sources are traversed directly. `applyeach` still lowers their nested
values.

The 3rd definition takes a `style` argument, allowing for overloads of non-owned types `T`.
The main difference between this and the 2nd definition is that the 3rd definition allows for
the `make` function to return a tuple of the constructed struct and any side-effect state
derived from making the struct.

The 4th definition allows passing in an already-constructed instance of `T` (`x`),
which must be mutable, and source key-value pairs will be applied as
to `x` as source keys are matched to struct field names.

For structs, `fieldtags` will be accounted for and certain tags can be used
to influence the construction of the struct.
"""
function make end

function make(::Type{T}, source, style::StructStyle=DefaultStyle()) where {T}
    x, _ = make(style, T, source)
    return x
end

if isdefined(Base, :delete) && applicable(Base.delete, (a=1,), :a)
    const _delete = Base.delete
else
    Base.@constprop :aggressive function delete(a::NamedTuple{an}, field::Symbol) where {an}
        names = Base.diff_names(an, (field,))
        NamedTuple{names}(a)
    end
    const _delete = delete
end

# Abstract collection targets are not constructible, so when the incoming value
# already satisfies the abstract type we must preserve it instead of rebuilding.
@inline abstractcollectionpassthrough(style::StructStyle, ::Type{T}, source) where {T} =
    isabstracttype(T) && source isa T && (dictlike(style, T) || arraylike(style, T))

# Non-struct sources opt into representation lowering at the root. Structural
# sources stay intact so a custom `lower` method can call `make` to traverse
# their fields without immediately calling itself again.
@inline _lowerrootsource(style::StructStyle, source) =
    structlike(style, source) ? source : lower(style, source)

# Keep normal `make` dispatch at the public boundary so exact custom methods
# and `@choosetype` methods win first. The concrete `Val{T}` token then gives
# the default implementation a specialized signature even when `T` is a
# Union, which avoids duplicating Union behavior in generated field code.
function make(style::StructStyle, ::Type{T}, source, tags) where {T}
    return _make(style, Val{T}(), source, tags)
end

function _make(style::StructStyle, ::Val{T}, source, tags) where {T}
    if haskey(tags, :choosetype)
        return make(style, tags.choosetype(source), source, _delete(tags, :choosetype))
    end
    if T !== Any
        if T >: Missing && T !== Missing
            if nulllike(style, source)
                return make(style, Missing, source, tags)
            else
                return make(style, nonmissingtype(T), source, tags)
            end
        elseif T >: Nothing && T !== Nothing
            if nulllike(style, source)
                return make(style, Nothing, source, tags)
            else
                return make(style, Base.nonnothingtype(T), source, tags)
            end
        end
        # for Union types like Union{T, Vector{T}} (after Nothing/Missing have been peeled),
        # we can disambiguate by checking if source is arraylike;
        # only applies when there's exactly one arraylike and one non-arraylike member
        if T isa Union
            types = Base.uniontypes(T)
            arr_type = nothing
            scalar_type = nothing
            ambiguous = false
            for t in types
                if arraylike(style, t)
                    # more than one arraylike type means we can't disambiguate
                    if arr_type !== nothing
                        ambiguous = true
                        break
                    end
                    arr_type = t
                else
                    if scalar_type !== nothing
                        ambiguous = true
                        break
                    end
                    scalar_type = t
                end
            end
            if !ambiguous && arr_type !== nothing && scalar_type !== nothing
                if arraylike(style, source)
                    return make(style, arr_type, source, tags)
                else
                    return make(style, scalar_type, source, tags)
                end
            end
        end
    end
    if T <: Tuple || dictlike(style, T) || arraylike(style, T) || noarg(style, T) || structlike(style, T)
        return make(style, T, source)
    else
        return lift(style, T, source, tags)
    end
end

function make(style::StructStyle, ::Type{T}, source) where {T}
    if abstractcollectionpassthrough(style, T, source)
        return source, defaultstate(style)
    end
    # start with some hard-coded Union cases
    if T !== Any
        if T >: Missing && T !== Missing
            if nulllike(style, source)
                return make(style, Missing, source)
            else
                return make(style, nonmissingtype(T), source)
            end
        elseif T >: Nothing && T !== Nothing
            if nulllike(style, source)
                return make(style, Nothing, source)
            else
                return make(style, Base.nonnothingtype(T), source)
            end
        end
        # for Union types like Union{T, Vector{T}} (after Nothing/Missing have been peeled),
        # we can disambiguate by checking if source is arraylike;
        # only applies when there's exactly one arraylike and one non-arraylike member
        if T isa Union
            types = Base.uniontypes(T)
            arr_type = nothing
            scalar_type = nothing
            ambiguous = false
            for t in types
                if arraylike(style, t)
                    # more than one arraylike type means we can't disambiguate
                    if arr_type !== nothing
                        ambiguous = true
                        break
                    end
                    arr_type = t
                else
                    if scalar_type !== nothing
                        ambiguous = true
                        break
                    end
                    scalar_type = t
                end
            end
            if !ambiguous && arr_type !== nothing && scalar_type !== nothing
                if arraylike(style, source)
                    return make(style, arr_type, source)
                else
                    return make(style, scalar_type, source)
                end
            end
        end
    end
    if T <: Tuple
        return maketuple(style, T, _lowerrootsource(style, source))
    elseif dictlike(style, T)
        lowered = _lowerrootsource(style, source)
        if abstractcollectionpassthrough(style, T, lowered)
            return lowered, defaultstate(style)
        end
        return makedict(style, T, lowered)
    elseif arraylike(style, T)
        lowered = _lowerrootsource(style, source)
        if abstractcollectionpassthrough(style, T, lowered)
            return lowered, defaultstate(style)
        end
        return makearray(style, T, lowered)
    elseif noarg(style, T)
        return makenoarg(style, T, _lowerrootsource(style, source))
    elseif structlike(style, T)
        return makestruct(style, T, _lowerrootsource(style, source))
    else
        return lift(style, T, source)
    end
end

if VERSION < v"1.11"
    mem(n) = Vector{Any}(undef, n)
else
    mem(n) = Memory{Any}(undef, n)
end

macro _t(i)
    esc(:(isassigned(vals, $i) ? @inbounds(vals[$i])::fieldtype(T, $i) : fielddefault(style, T, $i)::fieldtype(T, $i)))
end

@generated function _tuple(::Type{T}, vals, style) where {T}
    t = Expr(:tuple)
    for i = 1:fieldcount(T)
        push!(t.args, :(@_t($i)))
    end
    return Expr(:block, :(Base.@_inline_meta), t)
end

struct TupleClosure{T,A,S}
    vals::A
    style::S
    i::Ptr{Int}
end

function (f::TupleClosure{T,A,S})(k, v) where {T,A,S}
    st = _foreach(T) do i
        if typeof(k) == Int
            if k == i
                intval, intst = make(f.style, fieldtype(T, i), v)
                @inbounds f.vals[i] = intval
                return EarlyReturn(_MatchedState(intst))
            end
        else
            j = unsafe_load(f.i)
            if j == i
                unsafe_store!(f.i, i + 1)
                elseval, elsest = make(f.style, fieldtype(T, i), v)
                @inbounds f.vals[i] = elseval
                return EarlyReturn(_MatchedState(elsest))
            end
        end
    end
    return st isa _MatchedState ? st.value : unknownfield(f.style, T, k, v)
end

function maketuple(style, ::Type{T}, source) where {T}
    vals = mem(fieldcount(T))
    ref = Ref(1)
    GC.@preserve ref begin
        i = Base.unsafe_convert(Ptr{Int}, ref)
        st = applyeach(style, TupleClosure{T,typeof(vals),typeof(style)}(vals, style, i), source)
        return _tuple(T, vals, style), st
    end
end

struct DictClosure{T,S}
    dict::T
    style::S
end

function (f::DictClosure{T,S})(k, v) where {T,S}
    val, st = make(f.style, _valtype(f.dict), v)
    addkeyval!(f.dict, liftkey(f.style, _keytype(f.dict), k), val)
    return st
end

makedict(style, ::Type{T}, source) where {T} = makedict(style, initialize(style, T, source), source)

function makedict(style, dict::T, source) where {T}
    st = applyeach(style, DictClosure(dict, style), source)
    return dict, st
end

struct ArrayClosure{T,S}
    arr::T
    style::S
end

function (f::ArrayClosure{T,S})(_, v) where {T,S}
    val, st = make(f.style, eltype(f.arr), v)
    push!(f.arr, val)
    return st
end

struct FixedArrayClosure{A,S}
    arr::A
    style::S
    idx::Base.RefValue{Int}
end

function (f::FixedArrayClosure{A,S})(_, v) where {A,S}
    val, st = make(f.style, eltype(f.arr), v)
    i = f.idx[]
    @inbounds f.arr[i] = val
    f.idx[] = i + 1
    return st
end

function makearray(style, ::Type{T}, source) where {T}
    if fixedsizearray(style, T)
        ET = eltype(T)
        dims = discover_dims(style, T, source)
        L = prod(dims)
        if VERSION >= v"1.11"
            data = Memory{ET}(undef, L)
        else
            data = Vector{ET}(undef, L)
        end
        N = length(dims)
        if N > 1
            buf = reshape(data, dims)
            st = applyeach(style, MultiDimClosure(style, buf, ones(Int, N), Ref(N)), source)
        else
            st = applyeach(style, FixedArrayClosure(data, style, Ref(1)), source)
        end
        return arrayfromdata(T, data, dims), st
    else
        return @inline makearray(style, initialize(style, T, source), source)
    end
end

function makearray(style, x::T, source) where {T}
    if !(T <: AbstractSet) && ndims(T) > 1
        # multidimensional arrays
        n = ndims(T)
        st = applyeach(style, MultiDimClosure(style, x, ones(Int, n), Ref(n)), source)
        return x, st
    else
        st = applyeach(style, ArrayClosure(x, style), source)
        return x, st
    end
end

# NOTE for all @generated functions in this file: generator bodies avoid
# comprehensions/generators that capture `T` — each such closure type is
# specific to `Type{T}`, so running the generator would trigger fresh
# inference of `collect(Generator{...})` for every target type (measured at
# ~5-10ms per closure per type)
@generated function fieldnamestrings(::Type{T}) where {T}
    t = Expr(:tuple)
    for i = 1:fieldcount(T)
        push!(t.args, String(fieldname(T, i)))
    end
    return t
end

@generated function fieldnamesymbols(::Type{T}) where {T}
    t = Expr(:tuple)
    for i = 1:fieldcount(T)
        push!(t.args, QuoteNode(fieldname(T, i)))
    end
    return t
end

if VERSION < v"1.11"
    setval!(vals::Vector{Any}, x, i) = @inbounds vals[i] = x
else
    setval!(vals::Memory{Any}, x, i) = @inbounds vals[i] = x
end

setval!(vals::T, x, i) where {T} = _setfield!(vals, i, x)

# Struct-shaped targets are filled by a FieldSink: a source key is matched to
# a field index (see `cursorhit`/`matchscan` below), then the generated
# `applyfield!` ladder dispatches the index to a `make` call on that field's
# concrete type.

struct NoFieldMetadata end

struct FieldMetadata{FT}
    tags::FT
end

struct NoCursor end

@inline fieldmetadata(tags::Tuple{Vararg{@NamedTuple{}}}) = NoFieldMetadata()
@inline fieldmetadata(tags) = FieldMetadata(tags)

@inline sinktag(::NoFieldMetadata, ::Int) = (;)
@inline sinktag(metadata::FieldMetadata, i::Int) = @inbounds metadata.tags[i]

@inline ignoredfield(tags::NamedTuple{names}) where {names} =
    :ignore in names && tags.ignore

"""
    StructUtils.orderedfields(::StructStyle) -> Bool

Return `true` only when a style consumes source keys in field order and its
owned key type implements [`StructUtils.orderedfieldmatch`](@ref). This is an
internal, experimental integration hook. The source integration must own the
only key type for which `orderedfieldmatch` can return `true`; generic sources
must keep declaration-order matching.
"""
orderedfields(::StructStyle) = false

@inline fieldcursor(style, ::NoFieldMetadata) =
    orderedfields(style) ? Ref(1) : NoCursor()
@inline fieldcursor(style, ::FieldMetadata) = NoCursor()

struct FieldSink{T,S,V,M,C}
    vals::V           # Memory{Any} (immutable/NamedTuple targets) or the instance itself (noarg)
    style::S
    metadata::M       # empty marker or per-field tag NamedTuples, fetched once per `make`
    cursor::C         # NoCursor, or source-owned ordered-key cursor storage
end

FieldSink{T}(vals::V, style::S, metadata::M, cursor::C) where {T,S,V,M,C} =
    FieldSink{T,S,V,M,C}(vals, style, metadata, cursor)

# Key matching is two-phase. Phase 1 (`cursorhit`) is an internal opt-in for
# source-owned key types that can prove the next raw field-name match without
# changing `keyeq` semantics. Generic sources skip it: a custom key may match
# several fields and must always select the first one in declaration order.
# Phase 2 (`matchscan`) is a per-type generated scan with field-name literals.
@inline function matchone(k, ::NoFieldMetadata, i, fn, fstr)
    _ = i
    if typeof(k) == Symbol
        return keyeq(k, fn)
    else
        return keyeq(k, fstr)
    end
end

@inline function matchone(k, metadata::FieldMetadata, i, fn, fstr)
    tags = sinktag(metadata, i)
    if typeof(k) == Symbol
        name = get(tags, :name, fn)
        return keyeq(k, name) || keyeq(k, fn)
    else
        return keyeq(k, get(tags, :name, fstr))
    end
end

"""
    StructUtils.orderedfieldmatch(key, field::String) -> Bool

Return `true` when an integration-owned source-key type proves an exact raw
field-name match. This is an internal, experimental hook. Styles must also opt
in through [`StructUtils.orderedfields`](@ref), and the generic fallback must
remain `false`.
"""
@inline orderedfieldmatch(key, field::String) = false
@inline cursorhit(k, ::NoCursor, metadata, fstrs) = 0
@inline advancecursor!(::NoCursor, i::Int, n::Int) = nothing
@inline advancecursor!(cursor::Base.RefValue{Int}, i::Int, n::Int) =
    cursor[] = i == n ? 1 : i + 1

function cursorhit(k, cursor::Base.RefValue{Int}, metadata, fstrs)
    N = length(fstrs)
    # Tagged names can overlap. Preserve first-field scan order by using the
    # cursor only when every field has the default empty metadata.
    metadata isa NoFieldMetadata || return 0
    N == 0 && return 0
    i = cursor[]
    i > N && (i = 1)
    if orderedfieldmatch(k, @inbounds(fstrs[i]))
        cursor[] = i == N ? 1 : i + 1
        return i
    end
    return 0
end

@generated function matchscan(::Type{T}, k, metadata) where {T}
    ex = Expr(:block)
    for i = 1:fieldcount(T)
        fn = QuoteNode(fieldname(T, i))
        fstr = String(fieldname(T, i))
        push!(ex.args, :(matchone(k, metadata, $i, $fn, $fstr) && return $i))
    end
    push!(ex.args, :(return 0))
    return ex
end

# Splice each field type as a literal. Normal `make` dispatch remains visible,
# including exact custom methods; its default path uses the concrete Val token
# above for Union targets.
function _fieldmake(j::Int, @nospecialize(ft))
    return :(make(f.style, $ft, v, sinktag(f.metadata, $j)))
end

@generated function applyfield!(f::FieldSink{T}, i::Int, v) where {T}
    ex = Expr(:block)
    for j = 1:fieldcount(T)
        push!(ex.args, quote
            if i == $j
                ignoredfield(sinktag(f.metadata, $j)) && return defaultstate(f.style)
                val, st = $(_fieldmake(j, fieldtype(T, j)))
                setval!(f.vals, val, $j)
                return st
            end
        end)
    end
    push!(ex.args, :(return defaultstate(f.style)))
    return ex
end

function (f::FieldSink{T,S,V,M,C})(k, v) where {T,S,V,M,C}
    N = fieldcount(T)
    i = typeof(k) == Int ? ((1 <= k <= N) ? k : 0) :
        cursorhit(k, f.cursor, f.metadata, fieldnamestrings(T))
    if i == 0
        typeof(k) == Int && return unknownfield(f.style, T, k, v)
        i = matchscan(T, k, f.metadata)
        i == 0 && return unknownfield(f.style, T, k, v)
        advancecursor!(f.cursor, i, N)
    end
    return applyfield!(f, i, v)
end

# Build the sink for one make of `T` (tags fetched exactly once per make) and
# run the source through it. Generic sources use an allocation-free NoCursor;
# source integrations can provide private cursor storage for owned key types.
function fillfields!(style::StructStyle, ::Type{T}, vals, source) where {T}
    tags = _fieldtagtuple(style, T, fieldnamesymbols(T))
    metadata = fieldmetadata(tags)
    cursor = fieldcursor(style, metadata)
    return applyeach(style, FieldSink{T}(vals, style, metadata, cursor), source)
end

makenoarg(style, ::Type{T}, source) where {T} = makenoarg(style, initialize(style, T, source), source)

function makenoarg(style, y::T, source) where {T}
    st = fillfields!(style, T, y, source)
    return y, st
end

macro _v(i)
    esc(:(isassigned(vals, $i) ? @inbounds(vals[$i])::fieldtype(T, $i) : get(defs, @inbounds(fsyms[$i]), nothing)::fieldtype(T, $i)))
end

@generated function _construct(::Type{T}, vals, style, fsyms) where {T}
    n = fieldcount(T)
    # fast path: all fields assigned, skip fielddefaults entirely
    all_assigned = n == 0 ? true : :(isassigned(vals, 1))
    for i = 2:n
        all_assigned = Expr(:&&, all_assigned, :(isassigned(vals, $i)))
    end
    fast = Expr(:call, :T)
    slowcall = Expr(:call, :T)
    for i = 1:n
        push!(fast.args, :(@inbounds(vals[$i])::fieldtype(T, $i)))
        push!(slowcall.args, :(@_v($i)))
    end
    slow = Expr(:block, :(defs = fielddefaults(style, T, vals)), slowcall)
    return Expr(:block, :(Base.@_inline_meta), Expr(:if, all_assigned, fast, slow))
end

function makestruct(style, ::Type{T}, source) where {T}
    vals = mem(fieldcount(T))
    st = fillfields!(style, T, vals, source)
    if T <: NamedTuple
        return T(_tuple(T, vals, style)), st
    else
        return _construct(T, vals, style, fieldnamesymbols(T)), st
    end
end

make!(x::T, source; style::StructStyle=DefaultStyle()) where {T} = make!(style, x, source)
make!(::Type{T}, source; style::StructStyle=DefaultStyle()) where {T} = make!(style, T, source)

function make!(style::StructStyle, x::T, source) where {T}
    if dictlike(style, x)
        _, st = makedict(style, x, source)
    elseif arraylike(style, x)
        _, st = makearray(style, x, source)
    elseif noarg(style, x)
        _, st = makenoarg(style, x, source)
    else
        throw(ArgumentError("Type `$T` does not support in-place `make!`"))
    end
    return st
end

function make!(style::StructStyle, ::Type{T}, source) where {T}
    if abstractcollectionpassthrough(style, T, source)
        return source
    end
    x = initialize(style, T, source)
    make!(style, x, source)
    return x
end

"See [`make`](@ref)."
make!

"""
    StructUtils.reset!(x::T)

If `T` was defined with default values via `@defaults`, `@tags`, `@kwarg`, or `@noarg`,
`reset!` will reset the fields of `x` to their default values.
`T` must be a mutable struct type.
"""
function reset!(x::T; style::StructStyle=DefaultStyle()) where {T}
    if @generated
        N = fieldcount(T)
        ex = quote
            defs = fielddefaults(style, T)
        end
        for i = 1:N
            fname = Meta.quot(fieldname(T, i))
            push!(ex.args, quote
                if haskey(defs, $fname)
                    _setfield!(x, $i, defs[$fname])
                end
            end)
        end
        push!(ex.args, :(return x))
        return ex
    else
        defs = fielddefaults(style, T)
        for i = 1:fieldcount(T)
            fname = fieldname(T, i)
            if haskey(defs, fname)
                _setfield!(x, i, defs[fname])
            end
        end
        return x
    end
end

include("selectors.jl")

"""
    StructUtils.@choosetype T func
    StructUtils.@choosetype style T func

Convenience macro for defining a `StructUtils.make!` overload for an abstract type `T` where
`func` is a function that "chooses" a concrete type `S` at runtime. `func` can be one of two forms:
  * `source -> S`
  * `(source, tags) -> S)`

That is, it either takes just the `source` object that is passed to `make` and must choose a concrete
type `S`, or it can take both the `source` and a set of fieldtags that may be present for the field
of a type being "made".

The 2nd definition also takes a `style` argument, allowing for overloads of non-owned types `T`.

Example:

```julia
abstract type Vehicle end

struct Car <: Vehicle
    make::String
    model::String
    seatingCapacity::Int
    topSpeed::Float64
end

struct Truck <: Vehicle
    make::String
    model::String
    payloadCapacity::Float64
end

StructUtils.@choosetype Vehicle x -> x["type"] == "car" ? Car : x["type"] == "truck" ? Truck : throw(ArgumentError("Unknown vehicle type: \$(x["type"])"))

x = StructUtils.make(Vehicle, Dict("type" => "car", "make" => "Toyota", "model" => "Corolla", "seatingCapacity" => 4, "topSpeed" => 120.5))
@test x == Car("Toyota", "Corolla", 4, 120.5)
```
"""
macro choosetype(T, ex)
    esc(quote
        function StructUtils.make(st::StructUtils.StructStyle, ::Type{$T}, source, tags)
            func = $(ex)
            StructUtils.make(st, applicable(func, source, tags) ? func(source, tags) : func(source), source, tags)
        end
        function StructUtils.make(st::StructUtils.StructStyle, ::Type{$T}, source)
            func = $(ex)
            StructUtils.make(st, func(source), source)
        end
    end)
end

macro choosetype(style, T, ex)
    esc(quote
        function StructUtils.make(st::$(style), ::Type{$T}, source, tags)
            func = $(ex)
            StructUtils.make(st, applicable(func, source, tags) ? func(source, tags) : func(source), source, tags)
        end
        function StructUtils.make(st::$(style), ::Type{$T}, source)
            func = $(ex)
            StructUtils.make(st, func(source), source)
        end
    end)
end

end

@noarg mutable struct NoArg
end

@noarg mutable struct NoArg2
    no_type
    with_type::Int
    with_default = 1
    with_type_default::Int = 1
    with_tag &(xml=(key="with-tag",),)
    with_tag_type::Int &(xml=(key="with-tag-type",),)
    with_tag_default = 1 &(xml=(key="with-tag-default",),)
    with_tag_type_default::Int = 1 &(xml=(key="with-tag-default",),)
    @atomic no_type_atomic
    @atomic with_type_atomic::Int
    # atomic fields w/ defaults *must* use parens to disambiguate from atomic
    # variable assignment syntax: https://github.com/JuliaLang/julia/issues/53893
    @atomic(with_default_atomic) = 1
    @atomic(with_type_default_atomic::Int) = 1
    @atomic(with_tag_atomic) &(xml=(key="with-tag-atomic",),)
    @atomic(with_tag_type_atomic::Int) &(xml=(key="with-tag-type-atomic",),)
    @atomic(with_tag_default_atomic) = 1 &(xml=(key="with-tag-default-atomic",),)
    @atomic(with_tag_type_default_atomic::Int) = 1 &(xml=(key="with-tag-default-atomic",),)
end

abstract type AbstractNoArg end

@noarg mutable struct NoArg3{T, S <: IO} <: AbstractNoArg
    a::T = 10 * 20
    io::S
end

"""
Documentation for NoArg4
"""
@noarg mutable struct NoArg4
    a::String
end

@kwarg mutable struct KwDef1
    no_type
    with_type::Int
    with_default = 1
    with_type_default::Int = 1
    with_tag &(xml=(key="with-tag",),)
    with_tag_type::Int &(xml=(key="with-tag-type",),)
    with_tag_default = 1 &(xml=(key="with-tag-default",),)
    with_tag_type_default::Int = 1 &(xml=(key="with-tag-default",),)
    @atomic no_type_atomic
    @atomic with_type_atomic::Int
    @atomic(with_default_atomic) = 1
    @atomic(with_type_default_atomic::Int) = 1
    @atomic(with_tag_atomic) &(xml=(key="with-tag-atomic",),)
    @atomic(with_tag_type_atomic::Int) &(xml=(key="with-tag-type-atomic",),)
    @atomic(with_tag_default_atomic) = 1 &(xml=(key="with-tag-default-atomic",),)
    @atomic(with_tag_type_default_atomic::Int) = 1 &(xml=(key="with-tag-default-atomic",),)
    const no_type_const
    const with_type_const::Int
    const with_default_const = 1
    const with_type_default_const::Int = 1
    const with_tag_const &(xml=(key="with-tag-const",),)
    const with_tag_type_const::Int &(xml=(key="with-tag-type-const",),)
    const with_tag_default_const = 1 &(xml=(key="with-tag-default-const",),)
    const with_tag_type_default_const::Int = 1 &(xml=(key="with-tag-default-const",),)
end

@kwarg struct NoFields
end

@kwarg struct KwDef2{T, S <: IO} <: AbstractNoArg
    a::T = 10 * 20
    io::S
end

# tests from Base.@kwdef misc.jl
@kwarg struct Test27970Typed
    a::Int
    b::String = "hi"
end

@kwarg struct Test27970Untyped
    a
end

@kwarg struct Test27970Empty end

abstract type AbstractTest29307 end
@kwarg struct Test29307{T<:Integer} <: AbstractTest29307
    a::T=2
end

@kwarg struct TestInnerConstructor
    a = 1
    TestInnerConstructor(a::Int) = (@assert a>0; new(a))
    function TestInnerConstructor(a::String)
        @assert length(a) > 0
        new(a)
    end
end

const outsidevar = 7
@kwarg struct TestOutsideVar
    a::Int=outsidevar
end
@test TestOutsideVar() == TestOutsideVar(7)

@kwarg mutable struct Test_kwdef_const_atomic
    a
    b::Int
    c::Int = 1
    const d
    const e::Int
    const f = 1
    const g::Int = 1
    @atomic h::Int
end

@kwarg struct Test_kwdef_lineinfo
    a::String
end
# @testset "StructUtils.@kwdef constructor line info" begin
#     for method in methods(Test_kwdef_lineinfo)
#         @test method.file === Symbol(@__FILE__)
#         @test ((@__LINE__)-6) ≤ method.line ≤ ((@__LINE__)-5)
#     end
# end
@kwarg struct Test_kwdef_lineinfo_sparam{S<:AbstractString}
    a::S
end
# @testset "@kwdef constructor line info with static parameter" begin
#     for method in methods(Test_kwdef_lineinfo_sparam)
#         @test method.file === Symbol(@__FILE__)
#         @test ((@__LINE__)-6) ≤ method.line ≤ ((@__LINE__)-5)
#     end
# end

module KwdefWithEsc
    using StructUtils
    const Int1 = Int
    const val1 = 42
    macro define_struct()
        quote
            @kwarg struct $(esc(:Struct))
                a
                b = val1
                c::Int1
                d::Int1 = val1

                $(esc(quote
                    e
                    f = val2
                    g::Int2
                    h::Int2 = val2
                end))

                $(esc(:(i = val2)))
                $(esc(:(j::Int2)))
                $(esc(:(k::Int2 = val2)))

                l::$(esc(:Int2))
                m::$(esc(:Int2)) = val1

                n = $(esc(:val2))
                o::Int1 = $(esc(:val2))

                $(esc(:p))
                $(esc(:q)) = val1
                $(esc(:s))::Int1
                $(esc(:t))::Int1 = val1
            end
        end
    end
end

module KwdefWithEsc_TestModule
    using ..KwdefWithEsc
    const Int2 = Int
    const val2 = 42
    KwdefWithEsc.@define_struct()
end

@defaults struct Defaults1
    a::Int
    b::String
    c::Float64 = 3.14
    d::Int = 42
end

@defaults struct Defaults2{S <: IO, T} <: AbstractNoArg
    io::S
    a::T = 10 * 20
end

@defaults struct DefaultsAll
    id::Int = 0
    name::String = ""
    value::Float64 = 1.0
end

@defaults struct DefaultsPartial
    required::String
    optional1::Int = 10
    optional2::Bool = true
end

@tags struct TagsWithDefaults
    id::Int = 0 &(json=(name="identifier",),)
    name::String = "default" &(json=(name="full_name",),)
    score::Float64 = 0.0
end

@tags struct TagsPartialDefaults
    required::String &(json=(required=true,),)
    optional::Int = 42 &(json=(name="opt",),)
end

@testset "macros" begin

    @test NoArg() isa NoArg

    x = NoArg2()
    x.no_type = :hey
    @test x isa NoArg2
    @test StructUtils.noarg(StructUtils.DefaultStyle(), NoArg2)
    fd = StructUtils.fielddefaults(StructUtils.DefaultStyle(), NoArg2)
    @test fd.with_default == 1 && fd.with_type_default == 1 && fd.with_tag_default == 1 && fd.with_tag_type_default == 1 && fd.with_default_atomic == 1 && fd.with_type_default_atomic == 1 && fd.with_tag_default_atomic == 1 && fd.with_tag_type_default_atomic == 1
    ft = StructUtils.fieldtags(StructUtils.DefaultStyle(), NoArg2)
    @test ft.with_tag == (xml=(key="with-tag",),) && ft.with_tag_type == (xml=(key="with-tag-type",),) && ft.with_tag_default == (xml=(key="with-tag-default",),) && ft.with_tag_type_default == (xml=(key="with-tag-default",),) && ft.with_tag_atomic == (xml=(key="with-tag-atomic",),) && ft.with_tag_type_atomic == (xml=(key="with-tag-type-atomic",),) && ft.with_tag_default_atomic == (xml=(key="with-tag-default-atomic",),) && ft.with_tag_type_default_atomic == (xml=(key="with-tag-default-atomic",),)

    @static if VERSION >= v"1.11-DEV"
        @test @doc(NoArg4).text[1] == "Documentation for NoArg4\n"
    else
        @test string(@doc(NoArg4)) == "Documentation for NoArg4\n"
    end

    @test_throws ArgumentError @macroexpand StructUtils.@noarg struct NonMutableNoArg
        with_type::Int = 1
    end

    # can't use @noarg w/ struct w/ const fields
    @test_throws ArgumentError @macroexpand StructUtils.@noarg mutable struct NoArgConst
        const a::Int = 1
    end

    x = KwDef1(no_type=1, with_type=1, with_tag=1, with_tag_type=1, no_type_atomic=1, with_type_atomic=1, with_tag_atomic=1, with_tag_type_atomic=1, no_type_const=1, with_type_const=1, with_tag_const=1, with_tag_type_const=1)
    @test x.no_type == 1
    @test StructUtils.kwarg(StructUtils.DefaultStyle(), KwDef1)
    fd = StructUtils.fielddefaults(StructUtils.DefaultStyle(), KwDef1)
    @test fd.with_default == 1 && fd.with_type_default == 1 && fd.with_tag_default == 1 && fd.with_tag_type_default == 1 && fd.with_default_atomic == 1 && fd.with_type_default_atomic == 1 && fd.with_tag_default_atomic == 1 && fd.with_tag_type_default_atomic == 1 && fd.with_default_const == 1 && fd.with_type_default_const == 1 && fd.with_tag_default_const == 1 && fd.with_tag_type_default_const == 1
    ft = StructUtils.fieldtags(StructUtils.DefaultStyle(), KwDef1)
    @test ft.with_tag == (xml=(key="with-tag",),) && ft.with_tag_type == (xml=(key="with-tag-type",),) && ft.with_tag_default == (xml=(key="with-tag-default",),) && ft.with_tag_type_default == (xml=(key="with-tag-default",),) && ft.with_tag_atomic == (xml=(key="with-tag-atomic",),) && ft.with_tag_type_atomic == (xml=(key="with-tag-type-atomic",),) && ft.with_tag_default_atomic == (xml=(key="with-tag-default-atomic",),) && ft.with_tag_type_default_atomic == (xml=(key="with-tag-default-atomic",),) && ft.with_tag_const == (xml=(key="with-tag-const",),) && ft.with_tag_type_const == (xml=(key="with-tag-type-const",),) && ft.with_tag_default_const == (xml=(key="with-tag-default-const",),) && ft.with_tag_type_default_const == (xml=(key="with-tag-default-const",),)

    @test NoFields() isa NoFields

    @testset "No default values in @kwdef" begin
        @test Test27970Typed(a=1) == Test27970Typed(1, "hi")
        # Implicit type conversion (no assertion on kwarg)
        @test Test27970Typed(a=0x03) == Test27970Typed(3, "hi")
        @test_throws UndefKeywordError Test27970Typed()
    
        @test Test27970Untyped(a=1) == Test27970Untyped(1)
        @test_throws UndefKeywordError Test27970Untyped()
    
        # Just checking that this doesn't stack overflow on construction
        @test Test27970Empty() == Test27970Empty()
    end

    @testset "subtyped @kwdef" begin
        @test Test29307() == Test29307{Int}(2)
        @test Test29307(a=0x03) == Test29307{UInt8}(0x03)
        @test Test29307{UInt32}() == Test29307{UInt32}(2)
        @test Test29307{UInt32}(a=0x03) == Test29307{UInt32}(0x03)
    end

    @testset "@kwdef inner constructor" begin
        @test TestInnerConstructor() == TestInnerConstructor(1)
        @test TestInnerConstructor(a=2) == TestInnerConstructor(2)
        @test_throws AssertionError TestInnerConstructor(a=0)
        @test TestInnerConstructor(a="2") == TestInnerConstructor("2")
        @test_throws AssertionError TestInnerConstructor(a="")
    end

    @testset "const and @atomic fields in @kwdef" begin
        x = Test_kwdef_const_atomic(a = 1, b = 1, d = 1, e = 1, h = 1)
        for f in fieldnames(Test_kwdef_const_atomic)
            @test getfield(x, f) == 1
        end
        @testset "const fields" begin
            @test_throws ErrorException x.d = 2
            @test_throws ErrorException x.e = 2
            @test_throws MethodError x.e = "2"
            @test_throws ErrorException x.f = 2
            @test_throws ErrorException x.g = 2
        end
        @testset "atomic fields" begin
            @test_throws ConcurrencyViolationError x.h = 1
            @atomic x.h = 1
            @test @atomic(x.h) == 1
            @atomic x.h = 2
            @test @atomic(x.h) == 2
        end
    end

    @test isdefined(KwdefWithEsc_TestModule, :Struct)

    @test Defaults1(1, "hey") == Defaults1(1, "hey", 3.14, 42)
    io = IOBuffer()
    @test Defaults2(io) == Defaults2(io, 200)

    @test_throws ArgumentError @macroexpand @defaults struct FooFoo
        a::Int = 1
        b::String
    end

    # Test partial constructors with defaults
    @testset "@defaults partial constructors" begin
        # Test DefaultsAll - all fields have defaults
        @test DefaultsAll() == DefaultsAll(0, "", 1.0)
        @test DefaultsAll(5) == DefaultsAll(5, "", 1.0)
        @test DefaultsAll(5, "test") == DefaultsAll(5, "test", 1.0)
        @test DefaultsAll(5, "test", 2.5) == DefaultsAll(5, "test", 2.5)
        
        # Test DefaultsPartial - mixed required and default fields
        @test DefaultsPartial("required") == DefaultsPartial("required", 10, true)
        @test DefaultsPartial("required", 20) == DefaultsPartial("required", 20, true)
        @test DefaultsPartial("required", 20, false) == DefaultsPartial("required", 20, false)
    end

    @testset "@tags with defaults partial constructors" begin
        # Test TagsWithDefaults - all fields have defaults
        @test TagsWithDefaults() == TagsWithDefaults(0, "default", 0.0)
        @test TagsWithDefaults(1) == TagsWithDefaults(1, "default", 0.0)
        @test TagsWithDefaults(1, "custom") == TagsWithDefaults(1, "custom", 0.0)
        @test TagsWithDefaults(1, "custom", 99.9) == TagsWithDefaults(1, "custom", 99.9)

        # Test TagsPartialDefaults - mixed required and default fields
        @test TagsPartialDefaults("needed") == TagsPartialDefaults("needed", 42)
        @test TagsPartialDefaults("needed", 100) == TagsPartialDefaults("needed", 100)

        # Test that field tags are preserved
        ft = StructUtils.fieldtags(StructUtils.DefaultStyle(), TagsWithDefaults)
        @test ft.id == (json=(name="identifier",),)
        @test ft.name == (json=(name="full_name",),)

        # Test that field defaults are preserved
        fd = StructUtils.fielddefaults(StructUtils.DefaultStyle(), TagsWithDefaults)
        @test fd.id == 0
        @test fd.name == "default"
        @test fd.score == 0.0
    end

    @testset "fielddefaults with field references" begin
        # Test that fielddefaults works when one field's default references another field
        # This fixes a bug where fielddefaults would throw UndefVarError when evaluating
        # expressions like `b = a` because `a` wasn't in scope.
        @kwarg struct X
            a = 1
            b = a
        end
        fd = StructUtils.fielddefaults(StructUtils.DefaultStyle(), X)
        @test fd.a == 1
        @test fd.b == 1
        x = X()
        @test x.a == 1
        @test x.b == 1
    end

    @testset "computedefaults with parsed values" begin
        # Dependent default where first field has no default (the JSON.jl #430 case)
        @defaults struct ComputedA
            a::Int
            b::String = string(a)
        end
        # Direct construction still works
        @test ComputedA(42) == ComputedA(42, "42")
        # Deserialization: b computed from parsed a
        r = StructUtils.make(ComputedA, Dict(:a => 42))
        @test r.a == 42
        @test r.b == "42"
        # Both fields provided: b uses provided value, not computed
        r2 = StructUtils.make(ComputedA, Dict(:a => 42, :b => "hello"))
        @test r2.a == 42
        @test r2.b == "hello"

        # Dependent default where first field also has a default
        @defaults struct ComputedB
            a::Int = 0
            b::String = string(a)
        end
        # No fields provided: b computed from a's default
        r3 = StructUtils.make(ComputedB, Dict{Symbol,Any}())
        @test r3.a == 0
        @test r3.b == "0"
        # Only a provided: b computed from parsed a
        r4 = StructUtils.make(ComputedB, Dict(:a => 7))
        @test r4.a == 7
        @test r4.b == "7"

        # @kwarg with dependent defaults and deserialization
        @kwarg struct ComputedC
            a::Int = 1
            b::Int = a + 10
            c::Int = a + b
        end
        # All defaults
        r5 = StructUtils.make(ComputedC, Dict{Symbol,Any}())
        @test r5.a == 1
        @test r5.b == 11
        @test r5.c == 12
        # Override a, b and c recompute
        r6 = StructUtils.make(ComputedC, Dict(:a => 5))
        @test r6.a == 5
        @test r6.b == 15
        @test r6.c == 20
        # Override a and b, c recomputes from parsed values
        r7 = StructUtils.make(ComputedC, Dict(:a => 5, :b => 100))
        @test r7.a == 5
        @test r7.b == 100
        @test r7.c == 105

        # Non-macro struct: computedefaults falls back to fielddefaults
        struct ComputedPlain
            x::Int
            y::Int
        end
        r8 = StructUtils.make(ComputedPlain, Dict(:x => 1, :y => 2))
        @test r8.x == 1
        @test r8.y == 2

        # Expression-based default (not just field reference)
        @defaults struct ComputedD
            x::Int
            y::Int
            label::String = "$(x)-$(y)"
        end
        r9 = StructUtils.make(ComputedD, Dict(:x => 3, :y => 4))
        @test r9.label == "3-4"
    end

    @testset "type parameters in field types and defaults (#54)" begin
        # Issue 1 (#54): the 3-arg fielddefaults generated by @kwarg used to
        # insert `vals[i]::FieldType` assertions; when FieldType referenced one
        # of the struct's type parameters (e.g. `NTuple{N, Symbol}`), the
        # generated method had no `where {N}` binding and raised
        # `UndefVarError: N`.
        @kwarg struct Issue54{N}
            items::NTuple{N, Symbol} & (choosetype = x -> NTuple{length(x), Symbol},)
            ignored::Vector{Float64} = Float64[] & (ignore = true,)
        end
        source = Dict{String,Any}("items" => ["x", "y"])
        r = StructUtils.make(Issue54{2}, source)
        @test r.items == (:x, :y)
        @test r.ignored == Float64[]
        # also via the abstract type with `choosetype` resolving N
        r2 = StructUtils.make(Issue54, source)
        @test r2.items == (:x, :y)
        @test r2.ignored == Float64[]

        # Issue 2: default expressions that reference a type parameter (e.g.
        # `ntuple(_->0, N)`) used to throw `UndefVarError: N` because the
        # generated fielddefaults methods had no `where {N}`. For concrete
        # types we now emit a parameterized method that binds the parameters.
        @kwarg struct Issue54B{N}
            a::NTuple{N, Int} = ntuple(_->0, N)
            b::Int = sum(a)
        end
        @test StructUtils.fielddefaults(StructUtils.DefaultStyle(), Issue54B{3}) ==
              (a = (0, 0, 0), b = 0)
        @test Issue54B{3}() == Issue54B{3}((0, 0, 0), 0)
        @test StructUtils.make(Issue54B{3}, Dict{Symbol,Any}()) == Issue54B{3}((0, 0, 0), 0)
        # Parsed value of `a` flows into computed default for `b`.
        r3 = StructUtils.make(Issue54B{3}, Dict(:a => (1, 2, 3)))
        @test r3 == Issue54B{3}((1, 2, 3), 6)

        # Same for @noarg and @defaults — the generated fielddefaults methods
        # share the same code path.
        @noarg mutable struct Issue54C{N}
            a::NTuple{N, Int} = ntuple(_->0, N)
        end
        @test StructUtils.fielddefaults(StructUtils.DefaultStyle(), Issue54C{3}) ==
              (a = (0, 0, 0),)
        @test Issue54C{3}().a == (0, 0, 0)

        @defaults struct Issue54D{N}
            items::NTuple{N, Int}
            extra::NTuple{N, Int} = ntuple(_->0, N)
        end
        @test StructUtils.fielddefaults(StructUtils.DefaultStyle(), Issue54D{3}) ==
              (extra = (0, 0, 0),)
        @test Issue54D{3}((1, 2, 3)) == Issue54D{3}((1, 2, 3), (0, 0, 0))
    end

end # @testset "macros"

using StructUtils
using StructUtils.Selectors: @selectors

struct TrimA
    a::Int
    b::Int
    c::Int
    d::Int
end

@defaults struct TrimB
    a::Int
    b::Int
    c::Int = 0
    d::Int = 0
end

@defaults struct TrimC
    a::Int
    b::String = string(a)
end

@kwarg struct TrimD
    a::Int = 1
    b::Int = a + 10
    c::Int = a + b
end

@noarg mutable struct TrimE
    a::Int = 0
    b::Int = 0
end

@defaults struct TrimSimpleDefaults
    a::Int = 1
    b::String = "ok"
end

struct TrimStyle <: StructUtils.StructStyle end

StructUtils.fieldtagkey(::TrimStyle) = :trim
StructUtils.defaultstate(::TrimStyle) = :trim_state

@nonstruct struct TrimPoint
    x::Int
    y::Int
end

function _trim_point(s::AbstractString)::TrimPoint
    parts = split(s, ',')
    return TrimPoint(parse(Int, parts[1]), parse(Int, parts[2]))
end

Base.convert(::Type{TrimPoint}, s::AbstractString) = _trim_point(s)
StructUtils.lowerkey(::TrimStyle, p::TrimPoint) = "$(p.x),$(p.y)"
StructUtils.liftkey(::TrimStyle, ::Type{TrimPoint}, s::AbstractString) = _trim_point(s)

@tags struct TrimTagged
    id::Int &(trim=(name="identifier",),)
    code::Int
    ignored::Int = 99 &(trim=(ignore=true,),)
end

abstract type TrimVehicle end

struct TrimCarSource
    seats::Int
    wheels::Int
end

struct TrimTruckSource
    payload::Int
    axles::Int
end

struct TrimCar <: TrimVehicle
    seats::Int
    wheels::Int
end

struct TrimTruck <: TrimVehicle
    payload::Int
    axles::Int
end

trim_vehicle_type(::TrimCarSource) = TrimCar
trim_vehicle_type(::TrimTruckSource) = TrimTruck

StructUtils.@choosetype TrimVehicle trim_vehicle_type

struct TrimSelectorRecord
    key::Int
    value::Int
end

@selectors TrimSelectorRecord

function _assert_trim_public_traits()::Nothing
    StructUtils.dictlike(Dict{Symbol,Int}) || error("dictlike")
    StructUtils.arraylike(Vector{Int}) || error("arraylike vector")
    StructUtils.arraylike((1, 2)) || error("arraylike tuple")
    StructUtils.fixedsizearray(Matrix{Int}) || error("fixedsizearray")
    StructUtils.structlike(StructUtils.DefaultStyle(), TrimTagged) || error("structlike")
    StructUtils.noarg(StructUtils.DefaultStyle(), TrimE) || error("noarg")
    StructUtils.kwarg(StructUtils.DefaultStyle(), TrimD) || error("kwarg")
    StructUtils.nulllike(Nothing) || error("nulllike")
    StructUtils.keyeq(:id, "id") || error("keyeq")
    StructUtils.unknownfield(StructUtils.DefaultStyle(), TrimTagged, :extra, 1) === nothing || error("unknownfield")
    StructUtils.fielddefault(TrimStyle(), TrimSimpleDefaults, :a) == 1 || error("fielddefault")
    StructUtils.fielddefaults(TrimStyle(), TrimSimpleDefaults).b == "ok" || error("fielddefaults")
    StructUtils.fieldtags(TrimStyle(), TrimTagged, :id).name == "identifier" || error("fieldtags")
    StructUtils.discover_dims(StructUtils.DefaultStyle(), [1, 2, 3], 1) == (3,) || error("discover_dims")
    return nothing
end

function _assert_trim_applyeach(tagged::TrimTagged)::Nothing
    count = Ref(0)
    saw_id = Ref(false)
    saw_code = Ref(false)
    ret = StructUtils.applyeach(TrimStyle(), tagged) do k, v
        count[] += 1
        if k == "identifier"
            v == 1 || error("applyeach id")
            saw_id[] = true
        elseif k == :code
            v == 7 || error("applyeach code")
            saw_code[] = true
        end
        return nothing
    end
    ret === :trim_state || error("applyeach state")
    count[] == 2 || error("applyeach count")
    saw_id[] || error("applyeach id seen")
    saw_code[] || error("applyeach code seen")

    early = StructUtils.applyeach(TrimStyle(), tagged) do k, v
        k == :code && return StructUtils.EarlyReturn(v)
        return nothing
    end
    early isa StructUtils.EarlyReturn || error("EarlyReturn")
    early.value == 7 || error("EarlyReturn value")
    return nothing
end

function _assert_trim_selectors(tagged::TrimTagged)::Nothing
    _ = tagged
    record = TrimSelectorRecord(3, 7)
    propertynames(record) == [:key, :value] || error("selector propertynames")
    record.key == 3 || error("selector property")
    record[:value] == 7 || error("selector getindex")
    return nothing
end

function run_make_trim_sample()::Nothing
    _assert_trim_public_traits()

    a = StructUtils.make(TrimA, (a=1, b=2, c=3, d=4))
    a.a == 1 || error("TrimA.a")
    a.d == 4 || error("TrimA.d")

    a2 = StructUtils.make(TrimA, Dict{Symbol,Int}(:a => 1, :b => 2, :c => 3, :d => 4))
    a2.a == 1 || error("TrimA Dict")

    b1 = StructUtils.make(TrimB, (a=1, b=2, c=3, d=4))
    b1.c == 3 || error("TrimB all")

    b2 = StructUtils.make(TrimB, (a=1, b=2))
    b2.c == 0 || error("TrimB defaults")

    c1 = StructUtils.make(TrimC, (a=42,))
    c1.b == "42" || error("TrimC computed")

    c2 = StructUtils.make(TrimC, (a=42, b="hello"))
    c2.b == "hello" || error("TrimC provided")

    d1 = StructUtils.make(TrimD, (a=5,))
    d1.b == 15 || error("TrimD.b")
    d1.c == 20 || error("TrimD.c")

    e = StructUtils.make(TrimE, (a=10, b=20))
    e.a == 10 || error("TrimE.a")
    StructUtils.make!(e, (a=11, b=21))
    e.b == 21 || error("make!")
    StructUtils.reset!(e)
    e.a == 0 || error("reset!")

    nt = StructUtils.make(@NamedTuple{a::Int, b::Int}, (a=1, b=2))
    nt.a == 1 || error("NamedTuple")

    vector = StructUtils.make(Vector{Int}, (1, 2, 3))
    vector == [1, 2, 3] || error("Vector")

    point_dict = StructUtils.make(Dict{TrimPoint, Int}, Dict("1,2" => 12), TrimStyle())
    point_dict[TrimPoint(1, 2)] == 12 || error("liftkey")

    tagged = StructUtils.make(
        TrimTagged,
        (identifier=1, code=7),
        TrimStyle(),
    )
    tagged.id == 1 || error("TrimTagged id")
    tagged.ignored == 99 || error("TrimTagged default")

    _assert_trim_applyeach(tagged)
    _assert_trim_selectors(tagged)

    car = StructUtils.make(TrimVehicle, TrimCarSource(4, 4))
    car == TrimCar(4, 4) || error("@choosetype car")

    truck = StructUtils.make(TrimVehicle, TrimTruckSource(10, 3))
    truck == TrimTruck(10, 3) || error("@choosetype truck")

    scalar = StructUtils.make(TrimPoint, "8,9")
    scalar == TrimPoint(8, 9) || error("@nonstruct lift")

    return nothing
end

function @main(args::Vector{String})::Cint
    _ = args
    run_make_trim_sample()
    return 0
end

Base.Experimental.entrypoint(main, (Vector{String},))

"""
    Selection syntax

Special "selection syntax" is provided that allows easy querying of objects/arrays that implement `StructUtils.applyeach` using a syntax similar to XPath or CSS selectors,
applied using common Julia syntax.

This syntax mainly uses various forms of `getindex` to select elements of an object or array.
Supported syntax includes:
  * `x["key"]` / `x.key` / `x[:key]` / `x[1]` - select the value associated for a key in object `x` (key can be a String, Symbol, or Integer for an array)
  * `x[:]` - select all values in object or array `x`, returned as a `Selectors.List`, which is a custom array type that supports the selection syntax
  * `x.key` - when `x` is a `List`, select the value for `key` in each element of the `List` (like a broadcasted `getindex`)
  * `x[~, key]` - recursively select all values in object or array `x` that have `key`
  * `x[~, :]` - recursively select all values in object or array `x`, returned as a flattened `List`
  * `x[:, (k, v) -> Bool]` - apply a key-value function `f` to each key-value/index-value in object or array `x`, and return a `List` of all values for which `f` returns `true`
"""
module Selectors

using ..StructUtils

export List, @selectors

"""
    List(...)

A custom array wrapper that supports the Selectors selection syntax.
"""
struct List{T} <: AbstractVector{T}
    items::Vector{T}
end

items(x::List) = getfield(x, :items)
Base.getindex(x::List) = map(getindex, items(x))
List(T=Any) = List(T[])
Base.size(x::List) = size(items(x))
Base.eltype(::List{T}) where {T} = T
Base.isassigned(x::List, args::Integer...) = isassigned(items(x), args...)

Base.push!(x::List, item) = push!(items(x), item)
Base.append!(x::List, items_to_append) = append!(items(x), items_to_append)

StructUtils.arraylike(::StructUtils.StructStyle, ::List) = true

function StructUtils.applyeach(::StructUtils.StructStyle, f, x::List)
    # note that there should *never* be #undef
    # values in a list, since we only ever initialize empty
    # then push!/append! to it
    for (i, v) in enumerate(items(x))
        ret = f(i, v)
        ret isa StructUtils.EarlyReturn && return ret
    end
    return
end

const KeyInd = Union{AbstractString, Symbol}
const Inds = Union{AbstractVector{<:KeyInd}, NTuple{N, <:KeyInd} where {N},
    AbstractVector{<:Integer}, NTuple{N, <:Integer} where {N}}

# Union of all valid single-argument selector index types
const SelectorIndex = Union{KeyInd, Integer, Colon, Inds}

function _getindex_array(x, key::Union{KeyInd, Integer})
    values = List()
    StructUtils.applyeach(x) do _, item
        if StructUtils.structlike(StructUtils.DefaultStyle(), item)
            push!(values, _getindex(item, key))
        end
    end
    return values
end

function _getindex(x, key::Union{KeyInd, Integer})
    if StructUtils.arraylike(StructUtils.DefaultStyle(), x) && key isa KeyInd
        # indexing an array with a key, so we check
        # each element if it's an object and if the
        # object has the key
        # like a broadcasted getindex over x
        return _getindex_array(x, key)
    elseif StructUtils.structlike(StructUtils.DefaultStyle(), x) || StructUtils.arraylike(StructUtils.DefaultStyle(), x)
        # indexing object w/ key or array w/ index
        # returns a single value
        ret = StructUtils.applyeach(x) do k, v
            StructUtils.keyeq(k, key) && return StructUtils.EarlyReturn(v)
            return
        end
        ret isa StructUtils.EarlyReturn || throw(KeyError(key))
        return ret.value
    else
        noselection(x)
    end
end

# return all values of an object or elements of an array as a List
function _getindex(x, ::Colon)
    selectioncheck(x)
    values = List()
    StructUtils.applyeach(x) do _, v
        push!(values, v)
        return
    end
    return values
end

# a list is already a list of all its elements
_getindex(x::List, ::Colon) = x

# indexing object or array w/ a list of keys/indexes
function _getindex(x, inds::Inds)
    selectioncheck(x)
    values = List()
    StructUtils.applyeach(x) do k, v
        i = findfirst(StructUtils.keyeq(k), inds)
        i !== nothing && push!(values, v)
        return
    end
    return values
end

# return all values of an object or elements of an array as a List
# that satisfy a key-value function
function _getindex(x, S::Union{typeof(~), Colon}, f::Base.Callable)
    selectioncheck(x)
    values = List()
    StructUtils.applyeach(x) do k, v
        f(k, v) && push!(values, v)
        if S == ~
            if StructUtils.structlike(StructUtils.DefaultStyle(), v)
                ret = _getindex(v, ~, f)
                append!(values, ret)
            elseif StructUtils.arraylike(StructUtils.DefaultStyle(), v)
                ret = _getindex(v, ~, f)
                append!(values, ret)
            end
        end
        return
    end
    return values
end

# recursively return all values of an object or elements of an array as a List (:)
# as a single flattened List; or all properties that match key
function _getindex(x, ::typeof(~), key::Union{KeyInd, Colon})
    values = List()
    return _getindex(x, ~, key, values, key === Colon())
end

function _getindex(x, ::typeof(~), key::Union{KeyInd, Colon}, values, keymatched)
    if StructUtils.structlike(StructUtils.DefaultStyle(), x)
        StructUtils.applyeach(x) do k, v
            if key === Colon()
                _getindex(v, ~, key, values, true)
            elseif StructUtils.keyeq(k, key)
                # stop recursion if we find a match
                push!(values, v)
            else
                _getindex(v, ~, key, values, false)
            end
        end
    elseif StructUtils.arraylike(StructUtils.DefaultStyle(), x)
        StructUtils.applyeach(x) do _, item
            _getindex(item, ~, key, values, true)
        end
    elseif keymatched
        push!(values, x)
    end
    return values
end

# _get, like Base.get for objects
function _get(x, key::Union{KeyInd, Integer}, default)
    if StructUtils.arraylike(StructUtils.DefaultStyle(), x) && key isa KeyInd
        # indexing an array with a key, so we check
        # each element if it's an object and if the
        # object has the key
        # like a broadcasted getindex over x
        values = List()
        StructUtils.applyeach(x) do _, item
            if StructUtils.structlike(StructUtils.DefaultStyle(), item)
                # if array elements are objects, we do a broadcasted getproperty with `key`
                # should we try-catch and ignore KeyErrors?
                push!(values, _getindex(item, key))
            else
                # non-objects are just ignored
            end
            return
        end
        return values
    elseif StructUtils.structlike(StructUtils.DefaultStyle(), x) || StructUtils.arraylike(StructUtils.DefaultStyle(), x)
        # indexing object w/ key or array w/ index
        # returns a single value
        ret = StructUtils.applyeach(x) do k, v
            StructUtils.keyeq(k, key) && return StructUtils.EarlyReturn(v)
            return
        end
        ret isa StructUtils.EarlyReturn || return default
        return ret.value
    else
        noselection(x)
    end
end

selectioncheck(x) = StructUtils.structlike(StructUtils.DefaultStyle(), x) || StructUtils.arraylike(StructUtils.DefaultStyle(), x) || noselection(x)
@noinline noselection(x) = throw(ArgumentError("Selection syntax not defined for this object of type: `$(typeof(x))`"))

_symbol(x::AbstractString) = Symbol(x)
_symbol(x) = convert(Symbol, x)

# build up propertynames by iterating over each key-value pair
function _propertynames(x)
    selectioncheck(x)
    nms = Symbol[]
    StructUtils.applyeach(x) do k, _
        push!(nms, _symbol(k))
        return
    end
    return nms
end

# convenience macro for defining high-level getindex/getproperty methods
macro selectors(T)
    esc(quote
        Base.getindex(x::$T, arg::StructUtils.Selectors.SelectorIndex) = StructUtils.Selectors._getindex(x, arg)
        Base.getindex(x::$T, ::Colon, arg) = StructUtils.Selectors._getindex(x, :, arg)
        Base.getindex(x::$T, ::typeof(~), arg) = StructUtils.Selectors._getindex(x, ~, arg)
        Base.getindex(x::$T, ::typeof(~), key, val) = StructUtils.Selectors._getindex(x, ~, key, val)
        Base.get(x::$T, key::Symbol, def) = StructUtils.Selectors._get(x, key, def)
        Base.getproperty(x::$T, key::Symbol) = StructUtils.Selectors._getindex(x, key)
        Base.propertynames(x::$T) = StructUtils.Selectors._propertynames(x)
        Base.hasproperty(x::$T, key::Symbol) = key in propertynames(x)
        Base.length(x::$T) = StructUtils.applylength(x)
    end)
end

@selectors List

end # module

using Test, Dates, UUIDs, StructUtils

struct TestStyle <: StructUtils.StructStyle end
struct StrictUnknownFieldStyle <: StructUtils.StructStyle end
struct UnknownFieldTestError <: Exception
    target::Any
    key::Any
end

StructUtils.unknownfield(::StrictUnknownFieldStyle, ::Type{T}, key, value) where {T} =
    throw(UnknownFieldTestError(T, key))

mutable struct CountingTagStyle <: StructUtils.StructStyle
    calls::Int
end

struct CountingTagged
    a::Int
    b::Int
    c::Int
end

function StructUtils.fieldtags(st::CountingTagStyle, ::Type{CountingTagged})
    st.calls += 1
    return (a=(name="a",), b=(name="b",), c=(name="c",))
end

mutable struct PerFieldTagStyle <: StructUtils.StructStyle
    calls::Int
end

struct PerFieldTagged
    x::Int
    y::Int
end

function StructUtils.fieldtags(st::PerFieldTagStyle, ::Type{PerFieldTagged}, field)
    st.calls += 1
    field === :x && return (name="a",)
    field === :y && return (name="b",)
    return (;)
end

include(joinpath(dirname(pathof(StructUtils)), "../test/macros.jl"))
include(joinpath(dirname(pathof(StructUtils)), "../test/struct.jl"))
include(joinpath(dirname(pathof(StructUtils)), "../test/selectors.jl"))
include(joinpath(dirname(pathof(StructUtils)), "../test/construction.jl"))
include(joinpath(dirname(pathof(StructUtils)), "../test/ignore_inbound.jl"))
include(joinpath(dirname(pathof(StructUtils)), "../test/iso_lift.jl"))

@testset "StructUtils" begin

# Dict{Symbol, Int}, NamedTuple, A struct, Vector Pair
d = Dict(:a => 1, :b => 2, :c => 3, :d => 4)
ds = Dict("a" => 1, "b" => 2, "c" => 3, "d" => 4)
nt = (a = 1, b = 2, c = 3, d = 4)
a = A(1, 2, 3, 4)
aa = AA(1, 2, 3, 4, 5)
b = B(); b.a = 1; b.b = 2; b.c = 3; b.d = 4; b
bb = BB()
vp = [:a => 1, :b => 2, :c => 3, :d => 4]
v = [1, 2, 3, 4]
t = (1, 2, 3, 4)

println("Dict{Symbol, Int}")
@test StructUtils.make(Dict{Symbol, Int}, d) == d
@test StructUtils.make(Dict{Symbol, Int}, d) !== d
@test StructUtils.make(Dict{Symbol, Int}, ds) == d
@test StructUtils.make(Dict{Symbol, Int}, nt) == d
@test StructUtils.make(Dict{Symbol, Int}, a) == d
@test StructUtils.make(Dict{Symbol, Int}, vp) == d
# @test StructUtils.make(Dict{Symbol, Int}, aa) == d # fails because of extra field
@test StructUtils.make(Dict{Symbol, Int}, v) == Dict(Symbol(1) => 1, Symbol(2) => 2, Symbol(3) => 3, Symbol(4) => 4)
@test StructUtils.make(Dict{Symbol, Int}, t) == Dict(Symbol(1) => 1, Symbol(2) => 2, Symbol(3) => 3, Symbol(4) => 4)
@test StructUtils.make(Dict{Symbol, Int}, b) == d
@test StructUtils.make(Dict{Symbol, Int}, bb) == d
dmut = Dict{Symbol, Int}()
StructUtils.make!(dmut, d)
@test dmut == d

println("NamedTuple")
@test StructUtils.make(typeof(nt), d) == nt
@test StructUtils.make(typeof(nt), ds) == nt
@test StructUtils.make(typeof(nt), nt) == nt
@test StructUtils.make(typeof(nt), a) == nt
@test StructUtils.make(typeof(nt), vp) == nt
@test StructUtils.make(typeof(nt), v) == nt
@test StructUtils.make(typeof(nt), t) == nt
@test StructUtils.make(typeof(nt), aa) == nt # extra field is ignored
@test StructUtils.make(typeof(nt), b) == nt
@test StructUtils.make(typeof(nt), bb) == nt

println("A struct")
@test StructUtils.make(A, d) == a
@test StructUtils.make(A, ds) == a # slower
@test StructUtils.make(A, nt) == a
@test StructUtils.make(A, a) == a
@test StructUtils.make(A, vp) == a
@test StructUtils.make(A, v) == a # relies on order of vector elements
@test StructUtils.make(A, t) == a # relies on order of tuple elements
@test StructUtils.make(A, aa) == a # extra field is ignored
@test StructUtils.make(A, b) == a
@test StructUtils.make(A, bb) == a

println("AA struct")
@test StructUtils.make(AA, d) == aa # works because of AA field e default
@test StructUtils.make(AA, ds) == aa
@test StructUtils.make(AA, nt) == aa
@test StructUtils.make(AA, a) == aa
@test StructUtils.make(AA, vp) == aa
@test StructUtils.make(AA, v) == aa # relies on order of vector elements
@test StructUtils.make(AA, t) == aa # relies on order of tuple elements
@test StructUtils.make(AA, aa) == aa # extra field is ignored
@test StructUtils.make(AA, b) == aa
@test StructUtils.make(AA, bb) == aa

println("B struct")
@test StructUtils.make(B, d) == b
@test StructUtils.make(B, ds) == b
@test StructUtils.make(B, nt) == b
@test StructUtils.make(B, a) == b
@test StructUtils.make(B, bb) == b
bmut = B()
StructUtils.make!(bmut, d)
@test bmut == b

println("BB struct")
@test StructUtils.make(BB, d) == bb
@test StructUtils.make(BB, ds) == bb
@test StructUtils.make(BB, nt) == bb
@test StructUtils.make(BB, a) == bb
@test StructUtils.make(BB, vp) == bb
@test StructUtils.make(BB, v) == bb # relies on order of vector elements
@test StructUtils.make(BB, t) == bb # relies on order of tuple elements
@test StructUtils.make(BB, aa) == bb # extra field is ignored
@test StructUtils.make(BB, b) == bb
@test StructUtils.make(BB, bb) == bb

println("Vector Pair")
# @test StructUtils.make(typeof(vp), d) == vp # unordered Dict doesn't work
# @test StructUtils.make(typeof(vp), ds) == vp # unordered Dict doesn't work
@test StructUtils.make(typeof(vp), nt) == vp
@test StructUtils.make(typeof(vp), a) == vp
@test StructUtils.make(typeof(vp), vp) == vp

println("Vector")
# @test StructUtils.make(typeof(v), d) == v # relies on order of Dict elements
# @test StructUtils.make(typeof(v), ds) == v # relies on order of Dict elements
@test StructUtils.make(typeof(v), nt) == v
@test StructUtils.make(typeof(v), a) == v
@test StructUtils.make(typeof(v), vp) == v
@test StructUtils.make(typeof(v), v) == v
@test StructUtils.make(typeof(v), v) !== v
@test StructUtils.make(typeof(v), t) == v
# @test StructUtils.make(typeof(v), aa) == v # fails because of extra field

println("Abstract collections")
ad = Dict("a" => 1)
av = [1, 2, 3]

@test StructUtils.make(AbstractDict, ad) === ad
@test StructUtils.make(AbstractArray, av) === av
@test StructUtils.make(AbstractVector, av) === av
@test StructUtils.make!(AbstractDict, ad) === ad
@test StructUtils.make!(AbstractArray, av) === av
@test StructUtils.make!(AbstractVector, av) === av

x = StructUtils.make(AbstractDictHolder, Dict("d" => ad))
@test x.d === ad
x = StructUtils.make(AbstractArrayHolder, Dict("a" => av))
@test x.a === av
x = StructUtils.make(AbstractVectorHolder, Dict("v" => av))
@test x.v === av

println("Tuple")
# @test StructUtils.make(typeof(t), d) == t # relies on order of Dict elements
# @test StructUtils.make(typeof(t), ds) == t # relies on order of Dict elements
@test StructUtils.make(typeof(t), nt) == t
@test StructUtils.make(typeof(t), a) == t
@test StructUtils.make(typeof(t), vp) == t
@test StructUtils.make(typeof(t), v) == t
@test StructUtils.make(typeof(t), t) == t
@test StructUtils.make(typeof(t), aa) == t

@testset "unknownfield hook" begin
    @test StructUtils.make(A, nt, StrictUnknownFieldStyle()) == a
    @test_throws UnknownFieldTestError StructUtils.make(A, (a=1, b=2, c=3, d=4, e=5), StrictUnknownFieldStyle())
    @test_throws UnknownFieldTestError StructUtils.make(typeof(nt), aa, StrictUnknownFieldStyle())
    @test_throws UnknownFieldTestError StructUtils.make(typeof(t), [1, 2, 3, 4, 5], StrictUnknownFieldStyle())

    pmut2 = P()
    StructUtils.make!(pmut2, (id=0, name="Jane"); style=StrictUnknownFieldStyle())
    @test pmut2.id == 0 && pmut2.name == "Jane"
    @test_throws UnknownFieldTestError StructUtils.make!(pmut2, (id=0, name="Joan", rate=3.14); style=StrictUnknownFieldStyle())
end

@testset "target fieldtags are cached during make" begin
    style = CountingTagStyle(0)
    @test StructUtils.make(CountingTagged, (a=1, b=2, c=3), style) == CountingTagged(1, 2, 3)
    @test style.calls == 1

    perfield = PerFieldTagStyle(0)
    @test StructUtils.make(PerFieldTagged, (a=10, b=20), perfield) == PerFieldTagged(10, 20)
    @test perfield.calls == 2
end

println("C")
@test StructUtils.make(C, ()) == C()
@test StructUtils.make(C, (1,)) == C()

println("D")
@test StructUtils.make(D, (1, 3.14, "hey")) == D(1, 3.14, "hey")

println("Wrapper")
@test StructUtils.make(Wrapper, Dict("x" => Dict("a" => 1, "b" => "hey"))) == Wrapper((a=1, b="hey"))

println("UndefGuy")
x = StructUtils.make(UndefGuy, (id=1, name="2"))
@test x.id == 1 && x.name == "2"
x = StructUtils.make(UndefGuy, (id=1,))
@test x.id == 1 && !isdefined(x, :name)
x = UndefGuy()
StructUtils.make!(x, (id=1, name="2"))
@test x.id == 1 && x.name == "2"
x = UndefGuy()
StructUtils.make!(x, (id=1,))
@test x.id == 1 && !isdefined(x, :name)

println("E")
@test StructUtils.make(E, Dict("id" => 1, "a" => (a=1, b=2, c=3, d=4))) == E(1, A(1, 2, 3, 4))

println("G")
@test StructUtils.make(G, Dict("id" => 1, "rate" => 3.14, "name" => "Jim", "f" => Dict("id" => 2, "rate" => 6.28, "name" => "Bob"))) == G(1, 3.14, "Jim", F(2, 6.28, "Bob"))

println("H")
x = StructUtils.make(H, (id=0, name="", properties=Dict("a" => 1), addresses=["a", "b", "c"]))
@test x.id == 0 && x.name == "" && x.properties == Dict("a" => 1) && x.addresses == ["a", "b", "c"]

println("I")
@test StructUtils.make(I, (id=2, name="Aubrey", fruit=apple)) == I(2, "Aubrey", apple)

println("Vehicle")
StructUtils.@choosetype Vehicle x -> x["type"] == "car" ? Car : x["type"] == "truck" ? Truck : throw(ArgumentError("Unknown vehicle type: $(x["type"])"))

x = StructUtils.make(Vehicle, Dict("type" => "car", "make" => "Toyota", "model" => "Corolla", "seatingCapacity" => 4, "topSpeed" => 120.5))
@test x == Car("Toyota", "Corolla", 4, 120.5)

println("J")
@test StructUtils.make(J, (id=1, name=nothing, rate=3.14)) == J(1, nothing, 3.14)
@test StructUtils.make(J, (id=nothing, name=nothing, rate=3)) == J(nothing, nothing, 3)

println("Recurs")
@test StructUtils.make(Recurs, (id=0, value=(id=1, value=(id=2, value=(id=3, value=(id=4, value=nothing)))))) == Recurs(0, Recurs(1, Recurs(2, Recurs(3, Recurs(4, nothing)))))

println("O")
@test StructUtils.make(O, (id=0, name=missing)) == O(0, missing)
@test StructUtils.make(O, (id=0, name=nothing)) == O(0, nothing)
@test StructUtils.make(O, (id=0, name=(id=2, first_name="Jim", rate=3.14))) == O(0, L(2, "Jim", 3.14))
@test StructUtils.make(O, (id=0, name=(id=2, name="Jane", fruit=banana))) == O(0, I(2, "Jane", banana))

println("P")
p = StructUtils.make(P, (id=0, name="Jane"))
@test p.id == 0 && p.name == "Jane"
pmut = P()
StructUtils.make!(pmut, (id=0, name="Jane"))
@test pmut.id == 0 && pmut.name == "Jane"
StructUtils.make!(pmut, (id=0, name="Joan", rate=3.14))
@test pmut.id == 0 && pmut.name == "Joan"

println("Multi-dimensional arrays")
x = StructUtils.make(Matrix{Int}, [[1, 2, 3], [4, 5, 6], [7, 8, 9]])
@test x == [1 4 7; 2 5 8; 3 6 9]

println("Point")
@test StructUtils.make(Point, (x=1, y=2)) == Point(1, 2)
@test StructUtils.make(Dict{Point, Dict{Point, Point}}, Dict(Point(1, 2) => Dict(Point(3, 4) => Point(5, 6)))) == Dict(Point(1, 2) => Dict(Point(3, 4) => Point(5, 6)))
StructUtils.lowerkey(::StructUtils.StructStyle, p::Point) = "$(p.x)_$(p.y)"
StructUtils.liftkey(::StructUtils.StructStyle, ::Type{Point}, key::String) = Point(parse(Int, split(key, "_")[1]), parse(Int, split(key, "_")[2]))
@test StructUtils.make(Dict{Point, Dict{Point, Point}}, Dict("1_2" => Dict("3_4" => Point(5, 6)))) == Dict(Point(1, 2) => Dict(Point(3, 4) => Point(5, 6)))
@test StructUtils.make(Dict{Point, Dict{Point, Point}}, Dict(Point(1, 2) => Dict(Point(3, 4) => Point(5, 6)))) == Dict(Point(1, 2) => Dict(Point(3, 4) => Point(5, 6)))

# utils
@test StructUtils.applylength([1, 2, 3]) == 3
p = P()
p.id = 1
@atomic p.name = "Jane"
StructUtils.reset!(p)
@test p.name == "Jim"

println("Q")
@test StructUtils.make(Q, (id=0, value="application/json")) == Q(0, MIME("application/json"))

@testset "arraylike public API" begin
    @test StructUtils.arraylike([1]) == true
    @test StructUtils.arraylike((1, 2)) == true
    @test StructUtils.arraylike(Set([1])) == true
    @test StructUtils.arraylike(1) == false
end

@testset "applyeach with Pair" begin
    # Basic functionality - collect key-value pairs
    collected = []
    ret = StructUtils.applyeach(StructUtils.DefaultStyle(), (k, v) -> push!(collected, (k, v)), :a => 42)
    @test collected == [(:a, 42)]
    @test ret === nothing

    # Test EarlyReturn short-circuiting
    collected = []
    ret = StructUtils.applyeach(StructUtils.DefaultStyle(), (k, v) -> begin
        push!(collected, (k, v))
        return StructUtils.EarlyReturn("found")
    end, :x => 100)
    @test collected == [(:x, 100)]
    @test ret isa StructUtils.EarlyReturn
    @test ret.value == "found"

    # Test that lowerkey and lower are applied
    struct CustomStyle <: StructUtils.StructStyle end
    StructUtils.lowerkey(::CustomStyle, x::Symbol) = string(x)
    StructUtils.lower(::CustomStyle, x::Int) = x * 2
    StructUtils.defaultstate(::CustomStyle) = :custom_state

    collected = []
    ret = StructUtils.applyeach(CustomStyle(), (k, v) -> push!(collected, (k, v)), :test => 5)
    @test collected == [("test", 10)]  # key lowered to string, value doubled
    @test ret === :custom_state

    # Test EarlyReturn with custom style
    collected = []
    ret = StructUtils.applyeach(CustomStyle(), (k, v) -> begin
        push!(collected, (k, v))
        k == "test" && return StructUtils.EarlyReturn(:early)
        return nothing
    end, :test => 3)
    @test collected == [("test", 6)]
    @test ret isa StructUtils.EarlyReturn
    @test ret.value === :early

    # Test with nested structures
    collected = []
    StructUtils.applyeach(StructUtils.DefaultStyle(), (k, v) -> push!(collected, (k, v)), :nested => Dict(:a => 1, :b => 2))
    @test length(collected) == 1
    @test collected[1][1] === :nested
    @test collected[1][2] == Dict(:a => 1, :b => 2)

    # Test with nothing as value
    collected = []
    ret = StructUtils.applyeach(StructUtils.DefaultStyle(), (k, v) -> push!(collected, (k, v)), :key => nothing)
    @test collected == [(:key, nothing)]
    @test ret === nothing

    # Test that make works with Pair as source
    @test StructUtils.make(Dict{Symbol, Int}, :a => 1) == Dict(:a => 1)
    @test StructUtils.make(NamedTuple{(:a,), Tuple{Int}}, :a => 42) == (a=42,)
end

@testset "multidimensional make" begin
    # 2D Int matrix from nested vectors
    x2 = StructUtils.make(Matrix{Int}, [[1, 3], [2, 4]])
    @test x2 == [1 2; 3 4]

    # 2D Float64 matrix from singleton inner vectors
    x2f = StructUtils.make(Matrix{Float64}, [[1.0], [2.0]])
    m2f = Matrix{Float64}(undef, 1, 2)
    m2f[1] = 1.0
    m2f[2] = 2.0
    @test x2f == m2f

    # 2D Missing matrix
    xm = StructUtils.make(Matrix{Missing}, [[missing, missing], [missing, missing]])
    @test isequal(xm, [missing missing; missing missing])

    # 3D Int array
    # structure: two slabs, each a 2×1 slice
    x3 = StructUtils.make(Array{Int,3}, [[[1, 2]], [[3, 4]]])
    exp3 = Array{Int,3}(undef, 2, 1, 2)
    # fill slice [:, :, 1] from first slab [[1,2]]
    exp3[:, :, 1] = reshape([1,2], 2, 1)
    # fill slice [:, :, 2] from second slab [[3,4]]
    exp3[:, :, 2] = reshape([3,4], 2, 1)
    @test x3 == exp3

    # Jagged nested vectors (Vector of Vectors)
    jagged = [[1, 2], [3, 4, 5], [6]]
    result = StructUtils.make(Vector{Vector{Int}}, jagged)
    @test result == jagged

    # Multi-dimensional case with jagged inner vectors
    vv_jagged = [[[1, 2], [3]], [[4, 5, 6], [7, 8]]]
    result_md = StructUtils.make(Array{Vector{Int}, 2}, vv_jagged)

    md_jagged = Array{Vector{Int}}(undef, 2, 2)
    md_jagged[1, 1] = [1, 2]
    md_jagged[2, 1] = [3]
    md_jagged[1, 2] = [4, 5, 6]
    md_jagged[2, 2] = [7, 8]
    @test result_md == md_jagged
end

@testset "@nonstruct macro" begin
    # Test basic @nonstruct functionality
    @test !StructUtils.structlike(StructUtils.DefaultStyle(), NonStructUnit)
    @test !StructUtils.structlike(StructUtils.DefaultStyle(), NonStructComplex)
    
    # Test that structlike returns false for @nonstruct types with style
    @test !StructUtils.structlike(StructUtils.DefaultStyle(), NonStructUnit)
    @test !StructUtils.structlike(StructUtils.DefaultStyle(), NonStructComplex)
    
    # Test that @nonstruct works with type parameters
    @test !StructUtils.structlike(StructUtils.DefaultStyle(), NonStructUnit)
    @test !StructUtils.structlike(StructUtils.DefaultStyle(), NonStructComplex)
end

@testset "@nonstruct representation in make: #29" begin
    mapping = Dict{String,Any}("leaf" => 1)
    value = NonStructMapping(mapping)

    # Root values use the same representation as values nested in a source.
    @test StructUtils.make(Dict{String,Any}, value) == mapping
    @test StructUtils.make(NonStructMappingTarget, value) == NonStructMappingTarget(1)

    @test StructUtils.make(
        Dict{String,Any},
        NonStructMappingHolder(value),
    ) == Dict{String,Any}("value" => mapping)
    @test StructUtils.make(Vector{Any}, Any[value]) == Any[mapping]
    @test StructUtils.make(
        Dict{String,Any},
        Dict{String,Any}("value" => value),
    ) == Dict{String,Any}("value" => mapping)

    # Lowering may produce a concrete value satisfying an abstract target.
    @test StructUtils.make(AbstractDict, value) === mapping
    @test StructUtils.make(
        AbstractNonStructMappingTarget,
        value,
    ) == ConcreteNonStructMappingTarget(1)

    # Style-specific lowering is honored exactly once at the root.
    style = NonStructMappingStyle(0)
    @test StructUtils.make(Dict{String,Any}, value, style) == mapping
    @test style.lower_calls == 1

    # A target-owned make hook still receives the raw source.
    hook_style = NonStructMappingStyle(0)
    made = StructUtils.make(NonStructCustomMakeTarget, value, hook_style)
    @test made.saw_raw_source
    @test hook_style.lower_calls == 0

    # Making a non-struct target continues to use lift on the raw source.
    @test StructUtils.make(NonStructMapping, mapping).value === mapping
end

@testset "struct-like lower may call make: #66" begin
    style = RecursiveLowerStyle()
    value = RecursiveLowerRoot(RecursiveLowerLeaf(2), "root")
    expected = Dict{String,Any}(
        "leaf" => Dict{String,Any}("value" => 2),
        "label" => "root",
    )

    @test StructUtils.lower(style, value) == expected
    @test StructUtils.make(style, Dict{String,Any}, value) == (expected, nothing)
    @test StructUtils.make(Dict{String,Any}, value, style) == expected
end

@testset "Set make: #13" begin
    @test StructUtils.make(Set{Symbol}, Any["FACTOR"]) == Set{Symbol}([:FACTOR])
end

@testset "Empty NamedTuple structlike" begin
    # Test that empty named tuple value is struct-like
    empty_nt = (;)
    @test StructUtils.structlike(empty_nt) == true
    @test StructUtils.structlike(StructUtils.DefaultStyle(), empty_nt) == true
    
    # Test that empty named tuple type is struct-like
    @test StructUtils.structlike(typeof(empty_nt)) == true
    @test StructUtils.structlike(StructUtils.DefaultStyle(), typeof(empty_nt)) == true
    @test StructUtils.structlike(NamedTuple{(), Tuple{}}) == true
    @test StructUtils.structlike(StructUtils.DefaultStyle(), NamedTuple{(), Tuple{}}) == true
    
    # Test that make works with empty named tuples
    @test StructUtils.make(typeof(empty_nt), (;)) == (;)
    @test StructUtils.make(NamedTuple{(), Tuple{}}, Dict()) == (;)
    @test StructUtils.make(Dict{Symbol, Int}, (;)) == Dict{Symbol, Int}()
end

@testset "Union{scalar, array} disambiguation" begin
    # basic: scalar source → scalar type, array source → array type
    @test StructUtils.make(ScalarOrVec, (val=3.14,)).val === 3.14
    @test StructUtils.make(ScalarOrVec, (val=[1.0, 2.0],)).val == [1.0, 2.0]
    @test StructUtils.make(ScalarOrVec, (val=[1.0, 2.0],)).val isa Vector{Float64}

    # Any-typed sources (the case that actually fails without disambiguation)
    @test StructUtils.make(ScalarOrVec, Dict{String,Any}("val" => 3.14)).val === 3.14
    x = StructUtils.make(ScalarOrVec, Dict{String,Any}("val" => Any[1.0, 2.0]))
    @test x.val isa Vector{Float64}
    @test x.val == [1.0, 2.0]

    # String variant
    @test StructUtils.make(ScalarOrVecStr, (val="hello",)).val == "hello"
    x = StructUtils.make(ScalarOrVecStr, Dict{String,Any}("val" => Any["a", "b"]))
    @test x.val isa Vector{String}
    @test x.val == ["a", "b"]

    # Int variant
    @test StructUtils.make(ScalarOrVecInt, (val=42,)).val === 42
    x = StructUtils.make(ScalarOrVecInt, Dict{String,Any}("val" => Any[1, 2, 3]))
    @test x.val isa Vector{Int}
    @test x.val == [1, 2, 3]

    # with Nothing — Nothing is peeled first, then array/scalar split
    @test StructUtils.make(ScalarOrVecNothing, (val=nothing,)).val === nothing
    @test StructUtils.make(ScalarOrVecNothing, (val=5,)).val === 5
    x = StructUtils.make(ScalarOrVecNothing, Dict{String,Any}("val" => Any[1, 2]))
    @test x.val isa Vector{Int}
    @test x.val == [1, 2]

    # with Missing — Missing is peeled first, then array/scalar split
    @test StructUtils.make(ScalarOrVecMissing, (val=missing,)) == ScalarOrVecMissing(missing)
    @test StructUtils.make(ScalarOrVecMissing, (val=1.5,)).val === 1.5
    x = StructUtils.make(ScalarOrVecMissing, Dict{String,Any}("val" => Any[1.0, 2.0]))
    @test x.val isa Vector{Float64}
    @test x.val == [1.0, 2.0]

    # empty array → array type
    x = StructUtils.make(ScalarOrVec, (val=Float64[],))
    @test x.val isa Vector{Float64}
    @test isempty(x.val)

    # nested struct with Union field
    x = StructUtils.make(ScalarOrVecNested, Dict{String,Any}("id" => 1, "data" => Any[1.0, 2.0, 3.0]))
    @test x.id == 1
    @test x.data isa Vector{Float64}
    @test x.data == [1.0, 2.0, 3.0]
    x = StructUtils.make(ScalarOrVecNested, (id=1, data=3.14))
    @test x.id == 1
    @test x.data === 3.14

    # the original issue: Tuple with complex nested Union types
    x = StructUtils.make(FrankenTuple, (params=(nothing, [1.0, 2.0, 3.0], nothing),))
    @test x.params[1] === nothing
    @test x.params[2] isa Vector{Float64}
    @test x.params[2] == [1.0, 2.0, 3.0]
    @test x.params[3] === nothing
    # same tuple, all scalars
    x = StructUtils.make(FrankenTuple, (params=(1.0, 2.0, 3.0),))
    @test x.params[1] === 1.0
    @test x.params[2] === 2.0
    @test x.params[3] === 3.0

    # ambiguous: two arraylike types → should NOT be handled, falls through
    @test_throws Exception StructUtils.make(@NamedTuple{val::Union{Vector{Int}, Set{Int}}}, Dict{String,Any}("val" => Any[1, 2]))

    # Vector of structs with Union fields
    x = StructUtils.make(Vector{ScalarOrVec}, [(val=1.0,), (val=[2.0, 3.0],)])
    @test x[1].val === 1.0
    @test x[2].val isa Vector{Float64}
    @test x[2].val == [2.0, 3.0]
end

@testset "BigInt/BigFloat structlike" begin
    # BigInt and BigFloat are mutable structs in Julia, but should be treated
    # as non-struct types for serialization purposes (JuliaIO/JSON.jl#424)
    @test StructUtils.structlike(BigInt) == false
    @test StructUtils.structlike(BigFloat) == false
    @test StructUtils.structlike(StructUtils.DefaultStyle(), BigInt) == false
    @test StructUtils.structlike(StructUtils.DefaultStyle(), BigFloat) == false
end

@testset "keyeq with Tuple" begin
    # Test basic tuple functionality
    @test StructUtils.keyeq(:a, ("a", "b", "c"))
    @test StructUtils.keyeq("a", ("a", "b", "c"))
    @test StructUtils.keyeq("b", ("a", "b", "c"))
    @test StructUtils.keyeq("c", ("a", "b", "c"))
    @test !StructUtils.keyeq("d", ("a", "b", "c"))
    @test !StructUtils.keyeq(:d, ("a", "b", "c"))
    
    # Test with Symbol/String mixing
    @test StructUtils.keyeq(:myfield, ("MyField", "myfield", "field_my"))
    @test StructUtils.keyeq("MyField", ("MyField", "myfield", "field_my"))
    @test StructUtils.keyeq("myfield", ("MyField", "myfield", "field_my"))
    @test StructUtils.keyeq("field_my", ("MyField", "myfield", "field_my"))
    @test !StructUtils.keyeq("other", ("MyField", "myfield", "field_my"))
    
    # Test with empty tuple
    @test !StructUtils.keyeq("a", ())
    
    # Test with single element tuple
    @test StructUtils.keyeq("a", ("a",))
    @test !StructUtils.keyeq("b", ("a",))
    
    # Test that existing keyeq methods still work
    @test StructUtils.keyeq(:a, "a")
    @test StructUtils.keyeq("a", :a)
    @test StructUtils.keyeq("a", "a")
    @test StructUtils.keyeq(1, 1)
    @test !StructUtils.keyeq(1, 2)
    
    # Test practical use case: struct with alternative field names
    # Use name directly (not in a namespace) for DefaultStyle
    @tags struct SomeStruct
        my_field::Int & (name=("MyField", "myfield", "field_my"),)
    end
    
    # Test that make works with different key names
    @test StructUtils.make(SomeStruct, Dict("MyField" => 42)).my_field == 42
    @test StructUtils.make(SomeStruct, Dict("myfield" => 43)).my_field == 43
    @test StructUtils.make(SomeStruct, Dict("field_my" => 44)).my_field == 44
    # Test that the original field name still works
    @test StructUtils.make(SomeStruct, Dict(:my_field => 45)).my_field == 45
end

using StaticArrays

@testset "fixedsizearray trait" begin
    @test StructUtils.fixedsizearray(Matrix{Int}) == true
    @test StructUtils.fixedsizearray(Array{Float64, 3}) == true
    @test StructUtils.fixedsizearray(Vector{Int}) == false
    @test StructUtils.fixedsizearray(Set{Int}) == false
    @test StructUtils.fixedsizearray(SVector{3, Int}) == true
end

@testset "StaticArrays" begin
    @test StructUtils.make(SVector{3,Int}, [1, 2, 3]) == SVector{3,Int}((1, 2, 3))
    @test StructUtils.make(SVector{2,Float64}, [1, 2]) == SVector{2,Float64}((1.0, 2.0))
    @test StructUtils.make(SMatrix{2,2,Int}, [[1, 3], [2, 4]]) == SMatrix{2,2,Int}((1, 3, 2, 4))
    @test StructUtils.make(MVector{3,Int}, [1, 2, 3]) == MVector{3,Int}((1, 2, 3))
    @test StructUtils.make(Vector{SVector{2,Int}}, [[1, 2], [3, 4]]) == [SVector{2,Int}((1, 2)), SVector{2,Int}((3, 4))]
end

end

include("trim_compile_tests.jl")

using StructUtils, Tables, Test

@testset "tables.jl" begin
    tbl = (a=[1, 2, 3], b=[4, 5, 6])
    tbl2 = [StructUtils.make(@NamedTuple{a::Int, b::Int}, row) for row in Tables.rows(tbl)]
    @test length(tbl2) == 3
    @test tbl2[1].a == 1
    @test tbl2[1].b == 4
    @test tbl2[2].a == 2
    @test tbl2[2].b == 5
    @test tbl2[3].a == 3
    @test tbl2[3].b == 6
end

module StructUtilsTablesExt

using StructUtils, Tables

function StructUtils.applyeach(st::StructUtils.StructStyle, f, x::T) where {T <: Tables.AbstractRow}
    for nm in Tables.columnnames(x)
        ret = f(StructUtils.lowerkey(st, nm), StructUtils.lower(st, Tables.getcolumn(x, nm)))
        ret isa StructUtils.EarlyReturn && return ret
    end
    return StructUtils.defaultstate(st)
end

end # module

# Focused regression tests for struct-shaped construction (`makestruct`/`makenoarg`
# internals). These pin behavior that the field-matching/construction machinery
# must preserve regardless of how it is implemented.
using Test, StructUtils

# --- inner constructors must run (no construction bypass) ---
struct Positive
    x::Int
    function Positive(x)
        x > 0 || throw(ArgumentError("x must be positive"))
        return new(x)
    end
end

mutable struct CtorCounter
    n::Int
end
const CTOR_COUNTER = CtorCounter(0)
struct CountedCtor
    a::Int
    function CountedCtor(a)
        CTOR_COUNTER.n += 1
        return new(a)
    end
end

# --- stateful styles: metadata call cadence ---
mutable struct CadenceWholeStyle <: StructUtils.StructStyle
    calls::Int
end
mutable struct CadencePerFieldStyle <: StructUtils.StructStyle
    calls::Int
end

struct CadenceTagged
    a::Int
    b::Int
end

function StructUtils.fieldtags(style::CadenceWholeStyle, ::Type{CadenceTagged})
    style.calls += 1
    return (a=(name="A",), b=(name="B",))
end

function StructUtils.fieldtags(style::CadencePerFieldStyle, ::Type{CadenceTagged}, field::Symbol)
    style.calls += 1
    return (;)
end

# --- alias tuples and rename asymmetry ---
@tags struct AliasTupleT
    id::Int &(name=("ident", :idx),)
    code::Int
end

@tags struct RenamedT
    id::Int &(name="identifier",)
    code::Int
end

@tags struct CollidingName
    a::Int &(name="b",)
    b::Int
end
StructUtils.fielddefaults(::StructUtils.StructStyle, ::Type{CollidingName}) =
    (a=-1, b=-2)

@tags mutable struct MutableCollidingName
    a::Int &(name="b",)
    b::Int
    MutableCollidingName() = new(-1, -2)
end
StructUtils.noarg(::StructUtils.StructStyle, ::Type{MutableCollidingName}) = true

@tags struct OverlappingNames
    a::Int &(name="x",)
    b::Int &(name="x",)
end
StructUtils.fielddefaults(::StructUtils.StructStyle, ::Type{OverlappingNames}) =
    (a=-1, b=-2)

@tags struct ExplicitNothingName
    a::Int &(name=nothing,)
end
StructUtils.fielddefaults(::StructUtils.StructStyle, ::Type{ExplicitNothingName}) =
    (a=99,)

# --- nullable fields must retain normal custom make dispatch ---
abstract type NullableChoice end
struct ChosenValue <: NullableChoice
    x::Int
end
const OptionalChoice = Union{Nothing,NullableChoice}
StructUtils.@choosetype OptionalChoice source ->
    source === nothing ? Nothing : ChosenValue
struct ChoiceHolder
    value::OptionalChoice
end

struct CustomOptionalValue
    x::Int
end
const CustomOptional = Union{Nothing,CustomOptionalValue}
function StructUtils.make(
    style::StructUtils.StructStyle,
    ::Type{CustomOptional},
    source,
    tags,
)
    value = source === nothing ? nothing : CustomOptionalValue(source.x + 1)
    return value, StructUtils.defaultstate(style)
end
struct CustomOptionalHolder
    value::CustomOptional
end

struct WildcardKey end
StructUtils.keyeq(::WildcardKey, ::String) = true
struct WildcardTarget
    a::Int
    b::Int
end
StructUtils.fielddefaults(::StructUtils.StructStyle, ::Type{WildcardTarget}) =
    (a=-1, b=-2)

# --- shuffled key order ---
struct Ten
    f1::Int; f2::Int; f3::Int; f4::Int; f5::Int
    f6::Int; f7::Int; f8::Int; f9::Int; f10::Int
end

# --- wide struct (64 fields) ---
let fields = join(("g$i::Int" for i in 1:64), "\n")
    eval(Meta.parse("struct Wide64\n$fields\nend"))
end

@testset "struct construction regressions" begin
    @testset "inner constructor executes" begin
        @test StructUtils.make(Positive, (x=3,)) == Positive(3)
        @test_throws ArgumentError StructUtils.make(Positive, (x=-1,))
        @test_throws ArgumentError StructUtils.make(Positive, Dict("x" => -1))
        CTOR_COUNTER.n = 0
        @test StructUtils.make(CountedCtor, (a=7,)).a == 7
        @test CTOR_COUNTER.n == 1
    end

    @testset "stateful style call cadence" begin
        # whole-type fieldtags: exactly one call per make, per style instance
        s1 = CadenceWholeStyle(0)
        @test StructUtils.make(CadenceTagged, (A=1, B=2), s1) == CadenceTagged(1, 2)
        @test s1.calls == 1
        @test StructUtils.make(CadenceTagged, (A=3, B=4), s1) == CadenceTagged(3, 4)
        @test s1.calls == 2  # no cross-make caching
        s2 = CadenceWholeStyle(0)
        @test StructUtils.make(CadenceTagged, (A=5, B=6), s2) == CadenceTagged(5, 6)
        @test s2.calls == 1  # instances independent
        @test s1.calls == 2

        # per-field public fieldtags: one call per field per make
        p1 = CadencePerFieldStyle(0)
        @test StructUtils.make(CadenceTagged, (a=1, b=2), p1) == CadenceTagged(1, 2)
        @test p1.calls == 2
        @test StructUtils.make(CadenceTagged, (a=3, b=4), p1) == CadenceTagged(3, 4)
        @test p1.calls == 4
    end

    @testset "alias tuples and rename asymmetry" begin
        # every alias matches, from String- and Symbol-keyed sources
        @test StructUtils.make(AliasTupleT, Dict("ident" => 1, "code" => 2)) == AliasTupleT(1, 2)
        @test StructUtils.make(AliasTupleT, Dict("idx" => 1, "code" => 2)) == AliasTupleT(1, 2)
        @test StructUtils.make(AliasTupleT, Dict(:ident => 1, :code => 2)) == AliasTupleT(1, 2)
        @test StructUtils.make(AliasTupleT, Dict(:idx => 1, :code => 2)) == AliasTupleT(1, 2)
        # Symbol keys also match the original field name; String keys do not
        @test StructUtils.make(AliasTupleT, Dict(:id => 1, :code => 2)) == AliasTupleT(1, 2)
        @test_throws Exception StructUtils.make(AliasTupleT, Dict("id" => 1, "code" => 2))
        @test StructUtils.make(RenamedT, Dict(:id => 1, :code => 2)) == RenamedT(1, 2)
        @test StructUtils.make(RenamedT, Dict(:identifier => 1, :code => 2)) == RenamedT(1, 2)
        @test StructUtils.make(RenamedT, Dict("identifier" => 1, "code" => 2)) == RenamedT(1, 2)
        @test_throws Exception StructUtils.make(RenamedT, Dict("id" => 1, "code" => 2))
    end

    @testset "overlapping and explicit names" begin
        # Field matching is first-to-last for every source key. A cursor must
        # not let a later raw field bypass an earlier alias with the same name.
        @test StructUtils.make(CollidingName, [:a => 10, :b => 20]) ==
            CollidingName(20, -2)
        mutable_collision = StructUtils.make(MutableCollidingName, [:a => 10, :b => 20])
        @test (mutable_collision.a, mutable_collision.b) == (20, -2)
        @test StructUtils.make(OverlappingNames, ["x" => 1, "x" => 2]) ==
            OverlappingNames(2, -2)

        # An explicit `name=nothing` differs from an absent name for string
        # sources. Symbol sources still match the raw Julia field name.
        @test StructUtils.make(ExplicitNothingName, ["a" => 1]) ==
            ExplicitNothingName(99)
        @test StructUtils.make(ExplicitNothingName, [:a => 1]) ==
            ExplicitNothingName(1)
    end

    @testset "custom nullable dispatch" begin
        @test StructUtils.make(ChoiceHolder, (value=(x=2,),)) ==
            ChoiceHolder(ChosenValue(2))
        @test StructUtils.make(ChoiceHolder, (value=nothing,)) ==
            ChoiceHolder(nothing)
        @test StructUtils.make(CustomOptionalHolder, (value=(x=2,),)) ==
            CustomOptionalHolder(CustomOptionalValue(3))
        @test StructUtils.make(CustomOptionalHolder, (value=nothing,)) ==
            CustomOptionalHolder(nothing)
    end

    @testset "custom key precedence" begin
        @test StructUtils.make(
            WildcardTarget,
            [WildcardKey() => 1, WildcardKey() => 2],
        ) == WildcardTarget(2, -2)
    end

    @testset "shuffled key order" begin
        ordered = [Symbol("f$i") => i for i in 1:10]
        expected = StructUtils.make(Ten, ordered)
        @test expected == Ten((1:10)...)
        # reversed, interleaved, and rotated orders all produce the same value
        @test StructUtils.make(Ten, reverse(ordered)) == expected
        shuffled = [ordered[i] for i in [7, 2, 10, 4, 1, 9, 3, 6, 5, 8]]
        @test StructUtils.make(Ten, shuffled) == expected
        rotated = vcat(ordered[4:end], ordered[1:3])
        @test StructUtils.make(Ten, rotated) == expected
        # String keys, shuffled, with unknown keys interleaved (ignored by default)
        strkeys = vcat(["zzz" => 99], ["f$i" => i for i in 10:-1:1], ["extra" => -1])
        @test StructUtils.make(Ten, strkeys) == expected
    end

    @testset "wide struct" begin
        ordered = ["g$i" => i for i in 1:64]
        w = StructUtils.make(Wide64, ordered)
        @test all(getfield(w, i) == i for i in 1:64)
        # deterministic full-cycle permutation of key order
        perm = [(i * 37) % 64 + 1 for i in 0:63]
        @test length(unique(perm)) == 64
        shuffled = ["g$(p)" => p for p in perm]
        w2 = StructUtils.make(Wide64, shuffled)
        @test all(getfield(w2, i) == i for i in 1:64)
        @test w2 == w
    end
end

using StructUtils, Measurements, Test

@testset "measurements.jl" begin
    m = 1.1 ± 3.3
    str = StructUtils.lower(m)
    @test str == "1.1 ± 3.3"
    m2 = StructUtils.lift(Measurements.Measurement{Float64}, str)
    @test m2 == m
end

struct A
    a::Int
    b::Int
    c::Int
    d::Int
end

struct AA
    a::Int
    b::Int
    c::Int
    d::Int
    e::Int
end

StructUtils.fielddefaults(::StructUtils.StructStyle, ::Type{AA}) = (e=5,)

mutable struct B
    a::Int
    b::Int
    c::Int
    d::Int
    B() = new()
end

StructUtils.noarg(::StructUtils.StructStyle, ::Type{B}) = true
Base.:(==)(b1::B, b2::B) = b1.a == b2.a && b1.b == b2.b && b1.c == b2.c && b1.d == b2.d

Base.@kwdef struct BB
    a::Int = 1
    b::Int = 2
    c::Int = 3
    d::Int = 4
end

StructUtils.kwarg(::StructUtils.StructStyle, ::Type{BB}) = true

struct C
end

struct D
    a::Int
    b::Float64
    c::String
end

struct LotsOfFields
    x1::String
    x2::String
    x3::String
    x4::String
    x5::String
    x6::String
    x7::String
    x8::String
    x9::String
    x10::String
    x11::String
    x12::String
    x13::String
    x14::String
    x15::String
    x16::String
    x17::String
    x18::String
    x19::String
    x20::String
    x21::String
    x22::String
    x23::String
    x24::String
    x25::String
    x26::String
    x27::String
    x28::String
    x29::String
    x30::String
    x31::String
    x32::String
    x33::String
    x34::String
    x35::String
end

struct Wrapper
    x::NamedTuple{(:a, :b), Tuple{Int, String}}
end

struct AbstractDictHolder
    d::AbstractDict
end

struct AbstractArrayHolder
    a::AbstractArray
end

struct AbstractVectorHolder
    v::AbstractVector
end

mutable struct UndefGuy
    id::Int
    name::String
    UndefGuy() = new()
end

StructUtils.noarg(::StructUtils.StructStyle, ::Type{UndefGuy}) = true

struct E
    id::Int
    a::A
end

Base.@kwdef struct F
    id::Int
    rate::Float64
    name::String
end

StructUtils.kwarg(::StructUtils.StructStyle, ::Type{F}) = true

Base.@kwdef struct G
    id::Int
    rate::Float64
    name::String
    f::F
end

StructUtils.kwarg(::StructUtils.StructStyle, ::Type{G}) = true

struct H
    id::Int
    name::String
    properties::Dict{String, Any}
    addresses::Vector{String}
end

@enum Fruit apple banana

struct I
    id::Int
    name::String
    fruit::Fruit
end

abstract type Vehicle end

struct Car <: Vehicle
    make::String
    model::String
    seatingCapacity::Int
    topSpeed::Float64
end

struct Truck <: Vehicle
    make::String
    model::String
    payloadCapacity::Float64
end

struct J
    id::Union{Int, Nothing}
    name::Union{String, Nothing}
    rate::Union{Int, Float64}
end

struct K
    id::Int
    value::Union{Float64, Missing}
end

Base.@kwdef struct System
    duration::Real = 0 # mandatory
    cwd::Union{Nothing, String} = nothing
    environment::Union{Nothing, Dict} = nothing
    batch::Union{Nothing, Dict} = nothing
    shell::Union{Nothing, Dict} = nothing
end

StructUtils.kwarg(::StructUtils.StructStyle, ::Type{System}) = true

struct L
    id::Int
    first_name::String
    rate::Float64
end

struct ThreeDates
    date::Date
    datetime::DateTime
    time::Time
end

struct M
    id::Int
    value::Union{Nothing,K}
end

struct Recurs
    id::Int
    value::Union{Nothing,Recurs}
end

struct N
    id::Int
    uuid::UUID
end

@tags struct O
    id::Int
    name::Union{I,L,Missing,Nothing} &(choosetype=x->isnothing(x) ? Nothing : ismissing(x) ? Missing : haskey(x, :fruit) ? I : L,)
end

@noarg mutable struct P
    id::Int
    @atomic(name::String) = "Jim"
end

struct Point
    x::Int
    y::Int
end

# Test structs for @nonstruct macro
@nonstruct struct NonStructUnit
    value::String
end

@nonstruct struct NonStructComplex
    id::Int
    data::String
end

@nonstruct struct NonStructMapping
    value::Any
end

StructUtils.lift(::Type{NonStructMapping}, value) = NonStructMapping(value)
StructUtils.lower(value::NonStructMapping) = value.value

struct NonStructMappingHolder
    value::NonStructMapping
end

struct NonStructMappingTarget
    leaf::Int
end

abstract type AbstractNonStructMappingTarget end

struct ConcreteNonStructMappingTarget <: AbstractNonStructMappingTarget
    leaf::Int
end

StructUtils.@choosetype AbstractNonStructMappingTarget source -> begin
    source isa NonStructMapping || error("expected the raw non-struct source")
    ConcreteNonStructMappingTarget
end

mutable struct NonStructMappingStyle <: StructUtils.StructStyle
    lower_calls::Int
end

function StructUtils.lower(style::NonStructMappingStyle, value::NonStructMapping)
    style.lower_calls += 1
    return value.value
end

struct NonStructCustomMakeTarget
    saw_raw_source::Bool
end

function StructUtils.make(
    style::NonStructMappingStyle,
    ::Type{NonStructCustomMakeTarget},
    source::NonStructMapping,
)
    return NonStructCustomMakeTarget(true), StructUtils.defaultstate(style)
end

struct Q
    id::Int
    value::MIME
end

# Union{scalar, array} disambiguation test types
struct ScalarOrVec
    val::Union{Float64, Vector{Float64}}
end

struct ScalarOrVecStr
    val::Union{String, Vector{String}}
end

struct ScalarOrVecInt
    val::Union{Int, Vector{Int}}
end

struct ScalarOrVecNothing
    val::Union{Int, Vector{Int}, Nothing}
end

struct ScalarOrVecMissing
    val::Union{Float64, Vector{Float64}, Missing}
end
Base.:(==)(a::ScalarOrVecMissing, b::ScalarOrVecMissing) = isequal(a.val, b.val)

struct ScalarOrVecNested
    id::Int
    data::Union{Float64, Vector{Float64}}
end

struct FrankenTuple
    params::Tuple{Union{Float64, Nothing}, Union{Vector{Float64}, Float64}, Union{Vector{Float64}, Float64, Nothing}}
end

module StructUtilsStaticArraysCoreExt

using StructUtils
using StaticArraysCore: StaticArray, size_to_tuple

StructUtils.fixedsizearray(::Type{<:StaticArray}) = true

StructUtils.discover_dims(style, ::Type{<:StaticArray{S}}, source) where {S<:Tuple} =
    size_to_tuple(S)

StructUtils.arrayfromdata(::Type{T}, buf::Vector, dims::Tuple) where {T<:StaticArray} =
    T(Tuple(buf))

if VERSION >= v"1.11"
    StructUtils.arrayfromdata(::Type{T}, mem::Memory, dims::Tuple) where {T<:StaticArray} =
        T(Tuple(mem))
end

end # module

using Test, StructUtils

mutable struct InboundAuditStyle <: StructUtils.StructStyle
    unknowns::Vector{Any}
end

StructUtils.fieldtagkey(::InboundAuditStyle) = :wire
StructUtils.defaultstate(::InboundAuditStyle) = :audit_state
function StructUtils.unknownfield(
    style::InboundAuditStyle,
    ::Type{T},
    key,
    value,
) where {T}
    push!(style.unknowns, (T, key, value))
    return :unknown_state
end

struct StrictInboundStyle <: StructUtils.StructStyle end
StructUtils.fieldtagkey(::StrictInboundStyle) = :wire
StructUtils.unknownfield(::StrictInboundStyle, ::Type{T}, key, value) where {T} =
    throw(ArgumentError("unknown $(repr(key)) for $T"))

@defaults struct PlainIgnored
    visible::Int = 1
    ignored::Int = 99 &(ignore=true,)
end

@defaults struct WireIgnored
    visible::Int = 1 &(wire=(name="shown",),)
    ignored::Int = 99 &(wire=(name="secret", ignore=true),)
    notignored::Int = 7 &(wire=(ignore=false,),)
end

@noarg mutable struct MutableWireIgnored
    visible::Int = 1 &(wire=(name="shown",),)
    ignored::Int = 99 &(wire=(name="secret", ignore=true),)
end

@testset "ignore=true on inbound make" begin
    @test StructUtils.make(PlainIgnored, (visible=2, ignored=200)) ==
        PlainIgnored(2, 99)
    @test StructUtils.make(PlainIgnored, Dict("visible" => 2, "ignored" => 200)) ==
        PlainIgnored(2, 99)
    @test StructUtils.make(PlainIgnored, [2, 200]) == PlainIgnored(2, 99)

    for source in (
        Dict{String,Int}("shown" => 2, "secret" => 200, "notignored" => 8),
        Dict{Symbol,Int}(:shown => 2, :ignored => 200, :notignored => 8),
        [2, 200, 8],
    )
        style = InboundAuditStyle(Any[])
        value, state = StructUtils.make(style, WireIgnored, source)
        @test value == WireIgnored(2, 99, 8)
        @test state === :audit_state
        @test isempty(style.unknowns)
    end

    style = InboundAuditStyle(Any[])
    value, state = StructUtils.make(
        style,
        WireIgnored,
        ["shown" => 3, "secret" => 300, "extra" => 4],
    )
    @test value == WireIgnored(3, 99, 7)
    @test state === :audit_state
    @test style.unknowns == Any[(WireIgnored, "extra", 4)]

    @test StructUtils.make(WireIgnored, (secret=300,), StrictInboundStyle()) ==
        WireIgnored(1, 99, 7)
    @test_throws ArgumentError StructUtils.make(
        WireIgnored,
        (extra=4,),
        StrictInboundStyle(),
    )

    for source in (
        Dict{String,Int}("shown" => 2, "secret" => 200),
        Dict{Symbol,Int}(:shown => 2, :ignored => 200),
        [2, 200],
    )
        style = InboundAuditStyle(Any[])
        value = MutableWireIgnored()
        value.ignored = 55
        state = StructUtils.make!(style, value, source)
        @test value.visible == 2
        @test value.ignored == 55
        @test state === :audit_state
        @test isempty(style.unknowns)
    end
end

# The default lifts for Date, DateTime, and Time hand-parse ISO 8601 instead
# of calling the Dates constructors: the DateFormat machinery those route
# through is too dynamic for static compilation (`juliac --trim`). These
# tests pin the hand-rolled parsers to the Dates grammar that is stable across
# supported Julia versions. Julia 1.9 rejects signed years and year-only
# `DateTime` input that newer Julia versions accept, so those cases have
# explicit, version-independent expectations below.
@testset "ISO 8601 default lifts" begin
    datetime_cases = [
        "2020-01", "2020-1", "2020-01-01", "2020-1-1",
        "2020-01-01T10", "2020-01-01T10:20", "2020-01-01T10:20:30",
        "2020-01-01T10:20:30.4", "2020-01-01T10:20:30.45",
        "2020-01-01T10:20:30.456", "2020-01-01T10:20:30.4567",
        "12345-12-31T23:59:59.999", "2020-01-01 10:20:30",
        "garbage", "", "2020-13-01", "2020-01-32", "2020-", "2020-01-",
        "2020-01T", "2020-01-01T", "2020-01-01T10:", "2020-01-01T10:20:",
        "2020-01-01T10:20:30.", "2020-01-01T.", "-", "+", ".",
    ]
    date_cases = [
        "2020-01-01", "2020-1-1", "2020", "12345-01-01",
        "2020-01-01T10:20:30", "garbage", "2020-02-30", "", "2020-", "2020-01-",
    ]
    time_cases = [
        "10:20:30", "10:20", "10", "10:20:30.4", "10:20:30.456",
        "10:20:30.4567", "24:00:00", "10:61:00", "", "10:", "10:20:",
        "10:20:30.", "10.", "10:20:30. ",
    ]
    outcome(f, x) = try (:ok, f(x)) catch e; (:err, typeof(e)) end
    for c in datetime_cases
        @test outcome(x -> StructUtils.lift(DateTime, x), c) == outcome(DateTime, c)
    end
    for c in date_cases
        @test outcome(x -> StructUtils.lift(Date, x), c) == outcome(Date, c)
    end
    for c in time_cases
        @test outcome(x -> StructUtils.lift(Time, x), c) == outcome(Time, c)
    end

    # Keep the lift grammar stable on Julia 1.9 even where that version's
    # string constructors are narrower than later Julia versions.
    @test StructUtils.lift(DateTime, "2020") == DateTime(2020)
    @test StructUtils.lift(DateTime, "+2020-01-01") == DateTime(2020, 1, 1)
    @test StructUtils.lift(DateTime, "-0001-02-03T04:05:06.789") ==
          DateTime(-1, 2, 3, 4, 5, 6, 789)
    @test StructUtils.lift(Date, "-0001-02-03") == Date(-1, 2, 3)

    # `string` output round-trips exactly for every field combination.
    for dt in (DateTime(2026, 8, 7, 15, 0, 0, 76), DateTime(2020, 1, 1), DateTime(-1, 2, 3, 4, 5, 6, 789))
        @test StructUtils.lift(DateTime, string(dt)) == dt
    end
    for d in (Date(2026, 8, 7), Date(-1, 2, 3), Date(12345, 1, 1))
        @test StructUtils.lift(Date, string(d)) == d
    end
    for t in (Time(1, 2, 3), Time(1, 2, 3, 10), Time(23, 59), Time(0))
        @test StructUtils.lift(Time, string(t)) == t
    end

    # DateTime deliberately accepts RFC 3339 offsets — which `DateTime(str)`
    # rejects — and normalizes to UTC: offset-carrying timestamps are what
    # most JSON producers emit.
    @test StructUtils.lift(DateTime, "2026-08-07T15:00:00Z") ==
          DateTime(2026, 8, 7, 15)
    @test StructUtils.lift(DateTime, "2026-08-07T15:00:00.076Z") ==
          DateTime(2026, 8, 7, 15, 0, 0, 76)
    @test StructUtils.lift(DateTime, "2026-08-07T15:00:00+02:00") ==
          DateTime(2026, 8, 7, 13)
    @test StructUtils.lift(DateTime, "2026-08-07T15:00:00-04:30") ==
          DateTime(2026, 8, 7, 19, 30)
    @test_throws ArgumentError StructUtils.lift(DateTime, "2026-08-07T15:00:00+2:00")
    @test_throws ArgumentError StructUtils.lift(DateTime, "2020-01-01Z")

    # SubStrings lift like Strings.
    @test StructUtils.lift(DateTime, SubString("x2020-01-01x", 2, 11)) == DateTime(2020, 1, 1)

    # And the struct path uses the same lifts.
    three = StructUtils.make(ThreeDates, Dict(
        "date" => "2026-08-07",
        "datetime" => "2026-08-07T15:00:00.076",
        "time" => "12:30:15.25",
    ))
    @test three == ThreeDates(
        Date(2026, 8, 7),
        DateTime(2026, 8, 7, 15, 0, 0, 76),
        Time(12, 30, 15, 250),
    )
end

using Test, StructUtils
using StructUtils.Selectors: @selectors

# A simple wrapper struct for Vector{Pair{String, Any}}
struct StringPairs
    data::Vector{Pair{String, Any}}
end

# Apply the selectors macro to StringPairs
@selectors StringPairs

# Override applyeach to iterate over the wrapped Dict
function StructUtils.applyeach(st::StructUtils.StructStyle, f, x::StringPairs)
    for (k, v) in getfield(x, :data)
        ret = f(k, v)
        ret isa StructUtils.EarlyReturn && return ret
    end
    return
end

# Recursive helper to wrap nested Dicts and Arrays
wrap(x::Vector{<:Pair}) = StringPairs([k => wrap(v) for (k, v) in x])
wrap(x::Vector) = [wrap(v) for v in x]
wrap(x) = x

# Sample test data
raw = [
    "a" => 1,
    "b" => ["c" => 2, "d" => 3],
    "e" => [4, 5, 6],
    "f" => [["g" => 7], ["g" => 8]],
]
x = wrap(raw)

@testset "Selectors on StringPairs" begin
    # property names at root
    @test propertynames(x) == [:a, :b, :e, :f]

    # direct selection
    @test x.a == 1
    @test x["b"]["c"] == 2
    @test x.b.d == 3

    # select all direct values
    vals = collect(x[:])
    @test length(vals) == 4
    @test vals[1] == 1
    @test isa(vals[2], StringPairs)
    @test vals[3] == [4, 5, 6]
    @test isa(vals[4], Vector)

    # recursive flatten of all values
    flat = collect(x[~, :])
    @test flat == [1, 2, 3, 4, 5, 6, 7, 8]

    # recursive selection by key
    gvals = collect(x[~, "g"])
    @test gvals == [7, 8]

    # selection by array of keys
    be = collect(x[["b", "e"]])
    @test length(be) == 2
    @test isa(be[1], StringPairs)
    @test be[2] == [4, 5, 6]

    # filter selection at root by key predicate
    eonly = collect(x[:, (k, v) -> k == "e"])
    @test eonly == [[4, 5, 6]]

    # missing key throws KeyError
    @test_throws KeyError x["missing"]
end

# StructUtils.jl Documentation

StructUtils.jl provides flexible tools for working with Julia structs, making it easier to build, manipulate, and convert between different data structures. It offers macros for defining struct behaviors and a powerful `make` function for programmatic construction of objects from various data sources.

```@contents
Pages = ["index.md"]
Depth = 3
```

## Installation

The package is registered in the [`General`](https://github.com/JuliaRegistries/General) registry and can be installed at the REPL with:

```julia
] add StructUtils
```

## Quick Start

StructUtils.jl offers several key features:

1. **Struct definition macros** - Enhance struct definitions with special behaviors:
   ```julia
   using StructUtils
   
   # Define a struct with default values
   @defaults struct Config
       port::Int = 8080
       host::String = "localhost"
       debug::Bool = false
   end
   
   # Only need to provide non-default values
   config = Config(9000)  # Config(9000, "localhost", false)
   ```

2. **Programmatic object construction** - Convert between different data representations:
   ```julia
   # Convert a Dict to our Config struct
   dict = Dict(:port => 9000, :host => "example.com")
   config = StructUtils.make(Config, dict)  # Config(9000, "example.com", false)
   
   # Convert a Config back to a Dict
   dict_again = StructUtils.make(Dict{Symbol,Any}, config)  # Dict(:port => 9000, :host => "example.com", :debug => false)
   ```

## Core Concepts

StructUtils.jl is built around several key concepts:

1. **Struct Styles** - Define customization points for handling different struct types
2. **Field Tags** - Add metadata to struct fields for controlling serialization and deserialization
3. **Struct Macros** - Enhance struct definitions with special behaviors
4. **The `make` function** - Programmatically construct objects from various data sources

Let's explore each of these concepts in detail.

## Struct Styles

At the core of StructUtils.jl is the concept of a `StructStyle`:

```julia
abstract type StructStyle end
struct DefaultStyle <: StructStyle end
```

Struct styles provide a way to customize how structs are handled. The `DefaultStyle` is used by default, but you can create custom styles to override behavior for specific types, especially those you don't own:

```julia
struct MyCustomStyle <: StructStyle end

# Override behavior for a type you don't own
StructUtils.lift(::MyCustomStyle, ::Type{UUID}, x::AbstractString) = UUID(x)
```

This approach allows library authors to provide custom serialization/deserialization behavior for their types without modifying the original package.

## Struct Definition Macros

StructUtils.jl provides several macros to enhance struct definitions:

### `@nonstruct` - Non-struct-like Types

The `@nonstruct` macro marks a struct as not struct-like for StructUtils purposes. This is useful for custom types that should be treated as primitives rather than structs during serialization/deserialization:

```julia
@nonstruct struct Email
    value::String
end

# Define conversion methods
StructUtils.lift(::Type{Email}, x::String) = Email(x)
StructUtils.lower(x::Email) = x.value

# Now Email will be serialized as a string, not an object
user = User(email=Email("alice@example.com"))
dict = StructUtils.make(Dict{String,Any}, user)  # email field is a string
```

**Note**: `@nonstruct` does not support field defaults, tags, or other StructUtils macros since you're explicitly opting out of struct-like behavior.

### `@noarg` - No-argument Constructor

The `@noarg` macro creates a no-argument constructor for mutable structs and allows setting default values:

```julia
@noarg mutable struct User
    id::Int
    name::String
    created_at::DateTime = now()
    active::Bool = true
end

# Now you can create a User without arguments
user = User()  # Fields will be undefined except those with defaults
user.id = 1
user.name = "Alice"
```

### `@defaults` - Default Values

The `@defaults` macro creates an additional constructor that allows omitting arguments with default values:

```julia
@defaults struct Point
    x::Float64
    y::Float64
    z::Float64 = 0.0  # Default value
end

# You can omit the z argument
point = Point(1.0, 2.0)  # Point(1.0, 2.0, 0.0)
```

### `@kwarg` - Keyword Constructor

Similar to Base Julia's `@kwdef`, but with enhanced capabilities:

```julia
@kwarg struct HttpConfig
    port::Int = 8080
    host::String = "localhost"
    timeout::Int = 30
end

# Create with keyword arguments
config = HttpConfig(port=9000)  # HttpConfig(9000, "localhost", 30)
```

### `@tags` - Field Metadata

The `@tags` macro allows attaching metadata to struct fields using the `&(...)` syntax:

```julia
@tags struct Person
    id::Int &(json=(name="person_id",),)
    first_name::String &(json=(name="firstName",),)
    birth_date::Date &(dateformat="yyyy-mm-dd",)
    internal_note::String &(json=(ignore=true,),)
end
```

Each field can have tags that control how it's handled by different libraries. For example:

- `name` - Use a different name when serializing/deserializing
- `dateformat` - Specify a format for date parsing/formatting
- `ignore` - Skip this field during serialization/deserialization
- `lift`/`lower` - Custom functions to convert values during serialization/deserialization

## Field Tags Syntax

Field tags use a special syntax: `&(namespace=(key=value,),)`. The namespace (like `json`) allows different libraries to use their own tags without conflicts.

Common field tags include:

- `name`: Alternative name to use when matching source keys
- `ignore`: Skip this field during serialization/deserialization (boolean)
- `dateformat`: Format string or `DateFormat` object for date fields
- `lift`: Function to convert source values to field type
- `lower`: Function to convert field values to serialization format
- `choosetype`: Function to determine concrete type for abstract fields

Example of a field with multiple tags:

```julia
@tags struct Document
    id::Int &(json=(name="doc_id",), db=(column="document_id",))
    created::DateTime &(json=(dateformat="yyyy-mm-dd",), db=(column="creation_date",))
    data::Any &(json=(ignore=true,), db=(ignore=true,))
end
```

## The `make` Function

The core functionality of StructUtils.jl is in the `make` function, which creates an object of a specific type from a source object:

```julia
StructUtils.make(T, source) -> T
StructUtils.make(T, source, style) -> T
```

This function can convert between many kinds of objects:

```julia
# Convert a Dict to a struct
user = StructUtils.make(User, Dict("id" => 1, "name" => "Alice"))

# Convert a struct to a Dict
dict = StructUtils.make(Dict{String,Any}, user)

# Convert a struct to a NamedTuple
nt = StructUtils.make(NamedTuple, user)

# Convert a JSON object to a struct (with JSON.jl)
user = JSON.parse(json_string, User)  # Uses StructUtils.make under the hood
```

### How `make` Works

The `make` function follows these steps:

1. **Type Analysis**: Determine if the target type is:
   - Dictionary-like (`AbstractDict`, `Vector{Pair}`)
   - Array-like (`AbstractArray`, `Tuple`, `Set`)
   - No-arg constructible (`@noarg` or overridden `noarg` function)
   - Regular struct (default constructor)
   - Primitive type (requiring a `lift` function)

2. **Object Construction**:
   - For dictionary-like types: Create an empty dictionary and add key-value pairs
   - For array-like types: Create an empty array and push values
   - For no-arg types: Create an empty instance and set fields
   - For regular structs: Collect field values and call the constructor
   - For primitive types: Use `lift` to convert the source value

3. **Field Mapping**:
   - Match source keys to target fields, respecting field tags
   - Convert values to appropriate field types
   - Handle missing values, defaults, and special types

## Implementing StructUtils Interfaces

To make your types work well with StructUtils.jl, you can implement several interfaces:

### Type Classification

These functions determine how your type is handled by `make`:

```julia
# For dictionary-like types
StructUtils.dictlike(::Type{MyDict}) = true

# For array-like types
StructUtils.arraylike(::Type{MyArray}) = true

# For types with empty constructors
StructUtils.noarg(::Type{MyType}) = true

# For types with keyword constructors
StructUtils.kwdef(::Type{MyType}) = true
```

### Value Conversion

These functions control how values are converted during serialization/deserialization:

```julia
# Convert a source value to your type
StructUtils.lift(::Type{MyType}, x) = MyType(x)

# Convert a key to your type (for dictionary keys)
StructUtils.liftkey(::Type{MyType}, x::String) = MyType(parse(Int, x))

# Convert your type to a serializable form
StructUtils.lower(x::MyType) = string(x)

# Convert your type to a serializable key
StructUtils.lowerkey(x::MyType) = string(x)
```

### Field Metadata

These functions control field behavior:

```julia
# Define default values for fields
StructUtils.fielddefaults(::StructUtils.StructStyle, ::Type{MyType}) = (field1=1, field2="default")

# Define tags for fields
StructUtils.fieldtags(::StructUtils.StructStyle, ::Type{MyType}) = (field1=(name="f1",), field2=(ignore=true,))

# Define a namespace for field tags
StructUtils.fieldtagkey(::MyStyle) = :mylib
```

## Advanced Features

### Type Selection for Abstract Types

When working with abstract types, you need a way to determine the concrete type to construct. The `@choosetype` macro helps with this:

```julia
abstract type Vehicle end
struct Car <: Vehicle; make::String; model::String; end
struct Truck <: Vehicle; make::String; model::String; payload::Float64; end

# Define how to choose concrete types based on source data
StructUtils.@choosetype Vehicle x -> x["type"] == "car" ? Car : Truck

# Now make can create the right type
car = StructUtils.make(Vehicle, Dict("type" => "car", "make" => "Toyota", "model" => "Corolla"))
```

### The Selectors Module

StructUtils includes a `Selectors` module that provides a powerful way to query objects:

```julia
using StructUtils.Selectors

# Create a nested structure
data = Dict("users" => List([
    Dict("id" => 1, "name" => "Alice"),
    Dict("id" => 2, "name" => "Bob")
]))

# Query with selectors
users = data["users"]  # Get the users array
names = users[:].name  # Get all user names
```

The selector syntax supports various operations:
- `x["key"]` / `x.key` - Select by key
- `x[:]` - Select all values
- `x[~, "key"]` - Recursively select all values with key
- `x[:, (k,v) -> Bool]` - Filter by predicate

### Non-Struct-Like Structs with `@nonstruct`

What if you have a custom struct that you want behave more like a primitive type rather than a struct?

The `@nonstruct` macro is perfect for this use case. By marking your struct as non-struct-like, you tell StructUtils to treat it as a primitive type that should be converted directly using `lift` and `lower` methods rather than constructing it from field values.

Here's an example of a custom email type that should be serialized as a JSON string:

```julia
@nonstruct struct Email
    value::String
    
    function Email(value::String)
        # Validate email format
        if !occursin(r"^[^@]+@[^@]+\.[^@]+$", value)
            throw(ArgumentError("Invalid email format: $value"))
        end
        new(value)
    end
end

# Define how to convert from various sources to Email
StructUtils.lift(::Type{Email}, x::String) = Email(x)

# Define how to convert Email to a serializable format
StructUtils.lower(x::Email) = x.value

# Now you can use Email in your structs and it will be serialized as a string
@defaults struct User
    id::Int = 1
    name::String = "default"
    email::Email
end

# Create a user with an email
user = User(email=Email("alice@example.com"))

# Convert to Dict - email will be a string, not an object
dict = StructUtils.make(Dict{String,Any}, user)
# Result: Dict("id" => 1, "name" => "default", "email" => "alice@example.com")

# Convert back from Dict
user_again = StructUtils.make(User, dict)
```

Another example - a custom numeric type that represents a percentage:

```julia
@nonstruct struct Percent <: Number
    value::Float64
    
    function Percent(value::Real)
        if value < 0 || value > 100
            throw(ArgumentError("Percentage must be between 0 and 100"))
        end
        new(Float64(value))
    end
end

# Convert from various numeric types
StructUtils.lift(::Type{Percent}, x::Number) = Percent(x)
StructUtils.lift(::Type{Percent}, x::String) = Percent(parse(Float64, x))

# Convert to a simple number for serialization
StructUtils.lower(x::Percent) = x.value

# Use in a struct
@defaults struct Product
    name::String = "default"
    discount::Percent = Percent(0.0)
end

# Create and serialize
product = Product(discount=Percent(15.5))
dict = StructUtils.make(Dict{String,Any}, product)
# Result: Dict("name" => "default", "discount" => 15.5)
```

The key points about `@nonstruct`:

1. **No field defaults or tags**: Since you're opting out of struct-like behavior, field defaults and tags are not supported.

2. **Requires `lift` and `lower` methods**: You must define how to convert to/from your type.

3. **Fields are private**: The struct's fields are considered implementation details for the `make` process.

4. **Perfect for wrapper types**: Great for types that wrap primitives but need custom validation or behavior.

## Complex Example

Let's put everything together in a complex example, similar to the FrankenStruct example in the JSON.jl documentation:

```julia
using Dates, StructUtils

# Abstract type for polymorphism
abstract type AbstractMonster end

struct Dracula <: AbstractMonster
    num_victims::Int
end

struct Werewolf <: AbstractMonster
    witching_hour::DateTime
end

# Type chooser for AbstractMonster
StructUtils.@choosetype AbstractMonster x -> 
    x isa Dict && haskey(x, "monster_type") && x["monster_type"] == "vampire" ? 
    Dracula : Werewolf

# Custom numeric type with special parsing
@nonstruct struct Percent <: Number
    value::Float64
end

# Custom value lifting
StructUtils.lift(::Type{Percent}, x::Number) = Percent(Float64(x))
StructUtils.liftkey(::Type{Percent}, x::String) = Percent(parse(Float64, x))

# Our complex struct with various field types and defaults
@defaults struct FrankenStruct
    id::Int = 0
    name::String = "Jim"
    address::Union{Nothing, String} = nothing
    rate::Union{Missing, Float64} = missing
    type::Symbol = :a &(json=(name="franken_type",),)
    notsure::Any = nothing
    monster::AbstractMonster = Dracula(0)
    percent::Percent = Percent(0.0)
    birthdate::Date = Date(0) &(dateformat="yyyy/mm/dd",)
    percentages::Dict{Percent, Int} = Dict{Percent, Int}()
    matrix::Matrix{Float64} = Matrix{Float64}(undef, 0, 0)
end

# Create a FrankenStruct from a nested dictionary
source = Dict(
    "id" => 1,
    "address" => "123 Main St",
    "franken_type" => "b",
    "monster" => Dict("monster_type" => "vampire", "num_victims" => 10),
    "percent" => 0.1,
    "birthdate" => "2023/10/01",
    "percentages" => Dict("0.1" => 1, "0.2" => 2),
    "matrix" => [[1.0, 2.0], [3.0, 4.0]]
)

# Create a FrankenStruct from the source
frankenstein = StructUtils.make(FrankenStruct, source)

# Convert it back to a dictionary
dict_again = StructUtils.make(Dict{String,Any}, frankenstein)
```

In this example:

1. We define a polymorphic type hierarchy with `AbstractMonster`
2. We implement custom type selection using `@choosetype`
3. We define a custom numeric type `Percent` with special parsing
4. We create a complex struct with various field types and tags
5. We use `make` to create an instance from a nested dictionary

## Summary

StructUtils.jl provides a comprehensive suite of tools for working with Julia structs:

1. **Struct definition macros** enhance structs with special behaviors:
   - `@noarg` - No-argument constructor for mutable structs
   - `@defaults` - Default values for struct fields
   - `@kwarg` - Keyword constructor
   - `@tags` - Field metadata

2. **Field tags** provide metadata for fields:
   - `name` - Alternative name
   - `ignore` - Skip during serialization/deserialization
   - `dateformat` - Format for date fields
   - `lift`/`lower` - Custom conversion functions

3. **The `make` function** converts between different data representations:
   - Dict → Struct
   - Struct → Dict
   - Struct → NamedTuple
   - Array → Vector
   - etc.

4. **Custom interfaces** allow for specialized behavior:
   - Type classification (`dictlike`, `arraylike`, etc.)
   - Value conversion (`lift`, `lower`, etc.)
   - Field metadata (`fielddefaults`, `fieldtags`, etc.)

StructUtils.jl integrates well with other packages like JSON.jl for seamless serialization and deserialization of complex Julia types.
